// CSVHeaderDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RomLister.h"
#include "CSVHeaderDlg.h"
#include ".\csvheaderdlg.h"


// CCSVHeaderDlg dialog

IMPLEMENT_DYNAMIC(CCSVHeaderDlg, CDialog)
CCSVHeaderDlg::CCSVHeaderDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCSVHeaderDlg::IDD, pParent)
{
}

CCSVHeaderDlg::~CCSVHeaderDlg()
{
}

void CCSVHeaderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CSVHEADERLIST, m_listControl);
}


BEGIN_MESSAGE_MAP(CCSVHeaderDlg, CDialog)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_OK, OnBnClickedOk)
END_MESSAGE_MAP()

BEGIN_EASYSIZE_MAP(CCSVHeaderDlg)
	EASYSIZE(IDC_CSVHEADERLIST,ES_BORDER,ES_BORDER,ES_BORDER,ES_BORDER,0)
END_EASYSIZE_MAP

BOOL CCSVHeaderDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_listControl.SetExtendedStyle( LVS_EX_FULLROWSELECT );
	CString header;
	CString tmp;
	// "Name,120; ROM Name,80; Year,45; Manufacturer,115;"
	header = m_headersIn;
	header.Replace(",",",80;");
	m_listControl.SetHeadings( _T(header) );
	m_listControl.LoadColumnInfo();
	m_listControl.SetExtendedStyle( LVS_EX_HEADERDRAGDROP );

	int col=0;
	// insert the data contents for each header item so we don't lose the ordering when we re-arrange columns.
	m_listControl.AddItem("","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","");
	
	while (m_hiddenDataIn.GetLength() != 0)
	{
		tmp=m_hiddenDataIn.Left(m_hiddenDataIn.Find(",")+1);
		m_hiddenDataIn.Replace(tmp,"");
		m_hiddenDataIn.Trim();
		m_listControl.SetItemText(0,col,tmp);
		CString g=m_listControl.GetItemText(0,col);
		col++;
	}

	INIT_EASYSIZE;
	return TRUE;
}
void CCSVHeaderDlg::OnSize(UINT nType, int cx, int cy) 
{
    CDialog::OnSize(nType, cx, cy);
    UPDATE_EASYSIZE;
} 
void CCSVHeaderDlg::OnBnClickedOk()
{
	m_headersOut = "";
	m_hiddenDataOut = "";
	CHeaderCtrl* pHeaderCtrl = m_listControl.GetHeaderCtrl();
	int  nColumnCount = pHeaderCtrl->GetItemCount();
	LPINT pnOrder = (LPINT) malloc(nColumnCount*sizeof(int));
	ASSERT(pnOrder != NULL);
	m_listControl.GetColumnOrderArray(pnOrder, nColumnCount);
	
	for (int i=0; i<nColumnCount; i++)
	{
		CString tmp = GetColumnName(pnOrder[i]);
		m_headersOut+=tmp+",";
		m_hiddenDataOut+=m_listControl.GetItemText(0,pnOrder[i]);
	}
	m_headersOut.TrimRight(",");



	OnOK();
}
CString CCSVHeaderDlg::GetColumnName(  int nCol )
{
    CString strNome;
    CHeaderCtrl* pHdr = m_listControl.GetHeaderCtrl();
    if ( pHdr )
        if ( nCol < pHdr->GetItemCount() )
        {
            HDITEM hdi;
            hdi.mask = HDI_TEXT;
            hdi.pszText = strNome.GetBuffer( 256 );
            hdi.cchTextMax = 256;
            pHdr->GetItem( nCol, &hdi );
            strNome.ReleaseBuffer();
        }
    return strNome;
}

