// RLAllROMsListDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RomLister.h"
#include "RLAllROMsListDlg.h"
#include "fileStuff.h"
#include "GenericOutputDlg.h"
#include "xmlType.h"
#include "romlisterDlg.h"
#include "progressDlg.h"

// CRLAllROMsListDlg dialog

IMPLEMENT_DYNAMIC(CRLAllROMsListDlg, CDialog)
CRLAllROMsListDlg::CRLAllROMsListDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRLAllROMsListDlg::IDD, pParent)
{	
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CRLAllROMsListDlg::~CRLAllROMsListDlg()
{
}
BEGIN_MESSAGE_MAP(CRLAllROMsListDlg, CDialog)
		ON_WM_SIZE()
		ON_NOTIFY(NM_RCLICK, IDC_RLOUTPUTLIST, OnNMRclickList)
		ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
//		ON_BN_CLICKED(IDC_EXPORT, OnBnClickedExport)
		ON_NOTIFY(LVN_KEYDOWN, IDC_RLOUTPUTLIST, OnLvnKeydownRloutputlist)
		ON_NOTIFY(NM_DBLCLK, IDC_RLOUTPUTLIST, OnNMDblclkRloutputlist)
//		ON_BN_CLICKED(IDC_LISTPREVIEW, OnBnClickedListpreview)
//		ON_CBN_SELCHANGE(IDC_OUTPUTTYPE, OnCbnSelchangeOutputtype)
END_MESSAGE_MAP()

BEGIN_EASYSIZE_MAP(CRLAllROMsListDlg)
//  EASYSIZE(IDC_TITLE,ES_BORDER,ES_BORDER,
//  ES_BORDER,ES_KEEPSIZE,ES_HCENTER)
	EASYSIZE(IDC_RLOUTPUTLIST,ES_BORDER,ES_BORDER,ES_BORDER,ES_BORDER,0)
//	EASYSIZE(IDOK,ES_KEEPSIZE,ES_KEEPSIZE,ES_BORDER,ES_BORDER,0)
//	EASYSIZE(IDCANCEL,ES_KEEPSIZE,ES_KEEPSIZE,ES_BORDER,ES_BORDER,0)
//    EASYSIZE(IDC_OUTPUTTYPE,IDC_RLOUTPUTLIST,IDC_RLOUTPUTLIST,ES_BORDER,ES_BORDER,0)
//	EASYSIZE(IDC_EXPORT,IDC_RLOUTPUTLIST,IDC_RLOUTPUTLIST,ES_BORDER,ES_BORDER,0)
//	EASYSIZE(IDC_LISTPREVIEW,IDC_RLOUTPUTLIST,IDC_RLOUTPUTLIST,ES_BORDER,ES_BORDER,0)
END_EASYSIZE_MAP

BOOL CRLAllROMsListDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_listControl.SetExtendedStyle( LVS_EX_FULLROWSELECT );
	m_listControl.SetHeadings( _T("Key,0; Name,120; ROM Name,80; Year,45; Manufacturer,115;") );
	m_listControl.LoadColumnInfo();
	m_windowOpen=false;
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	INIT_EASYSIZE;
	return TRUE;
}
void CRLAllROMsListDlg::OnSize(UINT nType, int cx, int cy) 
{
    CDialog::OnSize(nType, cx, cy);
    UPDATE_EASYSIZE;
} 

void CRLAllROMsListDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_RLOUTPUTLIST, m_listControl);
}


void CRLAllROMsListDlg::OnBnClickedCancel()
{
	// hide the window instead of closing it/thread
	ShowWindow(SW_HIDE);
	// must kill the thread - don't call OnCancel
//!	DestroyWindow(); // this is how we do it
//	OnCancel();
}
void CRLAllROMsListDlg::PostNcDestroy()
{
	// this is how we kill the thread - step 2 - don't call base class
	if (this != NULL) 
		delete this;
	::PostQuitMessage(0);
//	CDialog::PostNcDestroy();
}

// CRLAllROMsListDlg message handlers

void CRLAllROMsListDlg::data2ListEntries()
{
	CProgressDlg progDlg;
	progDlg.Init(PROG_MODE_STANDARD, 1000, "Building list, one moment please...");
	m_listCount = 0;
	m_listControl.DeleteAllItems();

	CString key;
	CString name,rom,year,mfg; //,controls,buttons;
	// here we disect the data passed in from the initial query to display in the list box
	while (m_inputData.GetLength() > 0)
	{
		key = m_inputData.Left(m_inputData.Find("|"));
		m_inputData.TrimLeft(key);
		m_inputData.TrimLeft("|");

		rom = m_inputData.Left(m_inputData.Find("|"));
		m_inputData.TrimLeft(rom);
		m_inputData.TrimLeft("|");

		name = m_inputData.Left(m_inputData.Find("|"));
		m_inputData.TrimLeft(name);
		m_inputData.TrimLeft("|");

		year = m_inputData.Left(m_inputData.Find("|"));
		m_inputData.TrimLeft(year);
		m_inputData.TrimLeft("|");

		mfg = m_inputData.Left(m_inputData.Find("|"));
		m_inputData.TrimLeft(mfg);
		m_inputData.TrimLeft("|");

//		controls = m_inputData.Left(m_inputData.Find("|"));
//		m_inputData.TrimLeft(controls);
//		m_inputData.TrimLeft("|");
//
//		buttons = m_inputData.Left(m_inputData.Find("|"));
//		m_inputData.TrimLeft(buttons);
//		m_inputData.TrimLeft("|");

		m_listCount++;
	//	key.Format("%d",m_listCount);
		m_listControl.AddItem( key,name,rom,year,mfg); 
	}
	m_listControl.Sort(1,TRUE);

	m_windowTitle.Format(m_windowTitle, m_listCount);
	CDialog::SetWindowText(m_windowTitle);
	progDlg.DestroyWindow();
	m_windowOpen=true;

}
void CRLAllROMsListDlg::OnNMRclickList(NMHDR *pNMHDR, LRESULT *pResult)
{
	*pResult = 0;

	CPoint point;                                            
     ::GetCursorPos(&point); //where is the mouse?

	 CMenu menu; //lets display our context menu :) 

     DWORD dwSelectionMade;                                       
     VERIFY(menu.LoadMenu(IDR_MENU2) );  
     CMenu *pmenuPopup = menu.GetSubMenu(0);
     ASSERT(pmenuPopup != NULL);                                       
     dwSelectionMade = pmenuPopup->TrackPopupMenu( (TPM_LEFTALIGN|TPM_LEFTBUTTON|
                                                       TPM_NONOTIFY|TPM_RETURNCMD),
                                                       point.x, point.y, this
                                );                                
  
	 if (dwSelectionMade == ID_ADDTOLIST)
	 {
		 add2list();
	 }

	 if (dwSelectionMade == ID_DELETE_VIEWDETAILS)
	 {
		 showDetails();
	 }

	
     pmenuPopup->DestroyMenu(); 

}
void CRLAllROMsListDlg::showDetails()
{
	int nIndex=0;
	extern FILE* m_pinputFile;
	CGenericOutputDlg dlg;
	CString tmpDesc, romDesc, txt;	
	extern int g_xmlType;
	xmlType xmlData;
	CFileStuff m_file;

	// get the rom description
	nIndex = m_listControl.GetNextItem(-1, LVNI_SELECTED);
	romDesc = m_listControl.GetItemText(nIndex, 1);
	CString tmp = m_listControl.GetItemText(nIndex, 2);

	// reset the file
	m_file.resetFile(m_pinputFile);

	// get the entire description
	m_file.getROMDesc(m_pinputFile, tmpDesc, xmlData.ROMStart[g_xmlType]+"\""+tmp+"\"");

	// tweak it gently		
	tmpDesc.TrimLeft("\t");
	tmpDesc.Replace("\n\t","\r\n");	//remove 1 tab and replace CR with CR+LF combo 
	tmpDesc.TrimRight();

	if (m_hideSHA1s)
		{
			while (1)
			{
				int pos1 = tmpDesc.Find("<rom name=");
			if (pos1 == -1)
				break;
				int pos2 = tmpDesc.Find("/>\r\n",pos1);
			if (pos2 == -1)
				break;
				pos2+=4;
				tmpDesc.Replace(tmpDesc.Mid(pos1, pos2-pos1),"");

			}

		}

	// throw the data over the wall into the new dialog
	dlg.m_outputTxt = tmpDesc;
	dlg.m_title = romDesc;
	dlg.DoModal();
}
void CRLAllROMsListDlg::OnNMDblclkRloutputlist(NMHDR *pNMHDR, LRESULT *pResult)
{
	showDetails();
	*pResult = 0;
}

void CRLAllROMsListDlg::add2list()
{
	extern CRLOutPutDlgThd *gm_pRLOutputThd;
	int nIndex=-1;
	int lastDeleted=0;
	CString txt="";

	while (1) 
	{
		
		nIndex = m_listControl.GetNextItem(nIndex, LVNI_SELECTED);
		if (nIndex == -1)
			break;
		else
		{
			txt +=m_listControl.GetItemText(nIndex,0);	// key
			txt +="|";
			// gather up name and details for list
			txt += m_listControl.GetItemText(nIndex,2); 
			txt +="|";
			txt +=m_listControl.GetItemText(nIndex,1); 
			txt +="|";
			txt +=m_listControl.GetItemText(nIndex,3); 
			txt +="|";
			txt +=m_listControl.GetItemText(nIndex,4); 
			txt +="|";
		}
	}
	// throw this ROM name(s) over the wall into the working list thread.
	gm_pRLOutputThd->m_passthrough = txt;
	gm_pRLOutputThd->PostThreadMessage(WM_SET_DLG_FOCUS_COMMAND, 0, 0);
}

// jump through the list based on the first letter keypress.
//todo: the number stuff is really wonky - I think the keypress is getting passed through this routine and number keys = arrow keys too?
// would be great to be able to type in a name and let it continue finding the name beyond just the first letter.
void CRLAllROMsListDlg::OnLvnKeydownRloutputlist(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLVKEYDOWN pLVKeyDow = reinterpret_cast<LPNMLVKEYDOWN>(pNMHDR);
	*pResult = 0;

	int nIndex=0;
	int lastDeleted=0;
	CString txt="";

	if ( ( (pLVKeyDow->wVKey > 0x40) && (pLVKeyDow->wVKey < 0x5b) ) || ( (pLVKeyDow->wVKey > 47) && (pLVKeyDow->wVKey < 58) ) )
	{
		while (1) 
		{
			txt = m_listControl.GetItemText(nIndex,1);
			if (txt=="")
				return;
			if (txt.Left(1) == ((char)pLVKeyDow->wVKey) )
			{	
				m_listControl.EnsureVisible(nIndex, FALSE);
				m_listControl.SetSelectionMark(nIndex);
				m_listControl.SetItemState(nIndex, LVIS_SELECTED | LVIS_FOCUSED, 0xFF);
				m_listControl.RedrawItems(nIndex, nIndex);
				m_listControl.UpdateWindow();
				m_listControl.SetFocus();
				return;
			}
			else
				nIndex++;
		}
	}

}
