// RLOutput.cpp : implementation file
// this is the dialog for the user's "working list"

#include "stdafx.h"
#include "RomLister.h"
#include "RLOutput.h"
#include ".\rloutput.h"
#include "GenericOutputDlg.h"
#include "xmlType.h"
#include "csvDialog.h"
#include "MalaListDlg.h"
#include "malaListDef.h"
#include "fileStuff.h"
#include "batchFileDlg.h"
#include "progressDlg.h"
#include "CarbrioSettingsDlg.h"

// CRLOutput dialog

IMPLEMENT_DYNAMIC(CRLOutput, CDialog)
CRLOutput::CRLOutput(CWnd* pParent /*=NULL*/)
	: CDialog(CRLOutput::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CRLOutput::~CRLOutput()
{
}

void CRLOutput::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_RLOUTPUTLIST, m_listControl);
	DDX_Control(pDX, IDC_OUTPUTTYPE, m_exportFileType);
}


BEGIN_MESSAGE_MAP(CRLOutput, CDialog)
		ON_WM_SIZE()
		ON_NOTIFY(NM_RCLICK, IDC_RLOUTPUTLIST, OnNMRclickList)
		ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
		ON_BN_CLICKED(IDC_EXPORT, OnBnClickedExport)
		ON_NOTIFY(LVN_KEYDOWN, IDC_RLOUTPUTLIST, OnLvnKeydownRloutputlist)
		ON_NOTIFY(NM_DBLCLK, IDC_RLOUTPUTLIST, OnNMDblclkRloutputlist)
		ON_BN_CLICKED(IDC_LISTPREVIEW, OnBnClickedListpreview)
		ON_CBN_SELCHANGE(IDC_OUTPUTTYPE, OnCbnSelchangeOutputtype)
END_MESSAGE_MAP()

BEGIN_EASYSIZE_MAP(CRLOutput)
//  EASYSIZE(IDC_TITLE,ES_BORDER,ES_BORDER,
//  ES_BORDER,ES_KEEPSIZE,ES_HCENTER)
	EASYSIZE(IDC_RLOUTPUTLIST,ES_BORDER,ES_BORDER,ES_BORDER,ES_BORDER,0)
//	EASYSIZE(IDOK,ES_KEEPSIZE,ES_KEEPSIZE,ES_BORDER,ES_BORDER,0)
//	EASYSIZE(IDCANCEL,ES_KEEPSIZE,ES_KEEPSIZE,ES_BORDER,ES_BORDER,0)
    EASYSIZE(IDC_OUTPUTTYPE,IDC_RLOUTPUTLIST,IDC_RLOUTPUTLIST,ES_BORDER,ES_BORDER,0)
	EASYSIZE(IDC_EXPORT,IDC_RLOUTPUTLIST,IDC_RLOUTPUTLIST,ES_BORDER,ES_BORDER,0)
	EASYSIZE(IDC_LISTPREVIEW,IDC_RLOUTPUTLIST,IDC_RLOUTPUTLIST,ES_BORDER,ES_BORDER,0)
END_EASYSIZE_MAP


BOOL CRLOutput::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_listControl.SetExtendedStyle( LVS_EX_FULLROWSELECT );
	m_listControl.SetHeadings( _T("Key,0; Name,120; ROM Name,80; Year,45; Manufacturer,115;") );
	m_listControl.LoadColumnInfo();
	m_exportFileType.SetCurSel(0);

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	m_listCount = 0;
	m_previewIt = false;
	m_batchCmd = "copy %ROM%.zip c:\\mame\\roms";
	INIT_EASYSIZE;
	return TRUE;
}
void CRLOutput::OnSize(UINT nType, int cx, int cy) 
{
    CDialog::OnSize(nType, cx, cy);
    UPDATE_EASYSIZE;
} 

void CRLOutput::OnNMRclickList(NMHDR *pNMHDR, LRESULT *pResult)
{
	*pResult = 0;

	CPoint point;                                            
     ::GetCursorPos(&point); //where is the mouse?

	 CMenu menu; //lets display our context menu :) 

     DWORD dwSelectionMade;                                       
     VERIFY(menu.LoadMenu(IDR_MENU1) );  
     CMenu *pmenuPopup = menu.GetSubMenu(0);
     ASSERT(pmenuPopup != NULL);                                       
     dwSelectionMade = pmenuPopup->TrackPopupMenu( (TPM_LEFTALIGN|TPM_LEFTBUTTON|
                                                       TPM_NONOTIFY|TPM_RETURNCMD),
                                                       point.x, point.y, this
                                );                                
  
	 if (dwSelectionMade == ID_DELETE_DELETE)
	 {
		 deleteSelected();

	}

	 if (dwSelectionMade == ID_DELETE_VIEWDETAILS)
	 {
		 showDetails();
	 }

	
     pmenuPopup->DestroyMenu(); 

}
void CRLOutput::OnBnClickedCancel()
{
	ShowWindow(SW_HIDE);
	m_listControl.DeleteAllItems();
	m_inputData = "";
	m_listCount = 0;
	// must kill the thread - don't call OnCancel
//!	DestroyWindow(); // this is how we do it
//	OnCancel();
}
void CRLOutput::PostNcDestroy()
{
	// this is how we kill the thread - step 2 - don't call base class
	if (this != NULL) 
		delete this;
//	delete this;
	::PostQuitMessage(0);
//	CDialog::PostNcDestroy();
}

void CRLOutput::data2ListEntries()
{
	CString key;
	CString name,rom,year,mfg; //,controls,buttons;
	// here we disect the data passed in from the initial query to display in the list box
	while (m_inputData.GetLength() > 0)
	{
		key = m_inputData.Left(m_inputData.Find("|"));
		m_inputData.TrimLeft(key);
		m_inputData.TrimLeft("|");

		rom = m_inputData.Left(m_inputData.Find("|"));
		m_inputData.TrimLeft(rom);
		m_inputData.TrimLeft("|");

		name = m_inputData.Left(m_inputData.Find("|"));
		m_inputData.TrimLeft(name);
		m_inputData.TrimLeft("|");

		year = m_inputData.Left(m_inputData.Find("|"));
		m_inputData.TrimLeft(year);
		m_inputData.TrimLeft("|");

		mfg = m_inputData.Left(m_inputData.Find("|"));
		m_inputData.TrimLeft(mfg);
		m_inputData.TrimLeft("|");

//		controls = m_inputData.Left(m_inputData.Find("|"));
//		m_inputData.TrimLeft(controls);
//		m_inputData.TrimLeft("|");
//
//		buttons = m_inputData.Left(m_inputData.Find("|"));
//		m_inputData.TrimLeft(buttons);
//		m_inputData.TrimLeft("|");

		m_listCount++;
		m_listControl.AddItem( key,name,rom,year,mfg); 
	}
		m_listControl.Sort(1,TRUE);	// sort based on rom name
	// reusing key string for header of window
	key.Format("Your working list has %d ROMs", m_listCount);
	CDialog::SetWindowText(key);

}


// save working list to the output type the user wants.
// we're kinda sneaky here too in that if we want to preview the list, we skip the file-save dialog and then gather up the 
// output and throw it into a generic output dialog box.
void CRLOutput::OnBnClickedExport()
{
	// create a mala header structure
	malaListHeader malaHeader;
	CFileStuff fileStuff;
	CString m_sFilePath;
	CString m_ROMPath;
	CString roms;	// container for all the rom names we're interested in putting in our output file
	CString KhameleonListName;
	CString tmp, oldTmp;

	// gather all the keys from the list in the order they are available.
	// dedupe the list as well.  Since the names are automagically sorted, duplicates will be placed next to each other always.
	// deduping is then just seeing if just did the same thing
	for (int i=0; i<m_listCount; i++)
	{
		tmp= m_listControl.GetItemText(i, 0); // get the key (file position) for every rom in our list.
		if (oldTmp != tmp)
		{
			roms += tmp;
			roms+="|";
		}
		oldTmp = tmp;
	}

	// no preview?  then ask for a filename
	if (m_previewIt == false) 
	{
		// prep the filename for saving
		switch (m_exportFileType.GetCurSel())
		{
		 case AdvanceMenuLst:
			{
				m_FileFilter = "AdvanceMenu LST game list files (*.lst)\0*.lst\0";
				m_FileExt = "txt";
				break;
			}
		case Atomic:
			{
				m_FileFilter = "Atomic FE game list files (*.txt)\0*.txt\0";
				m_FileExt = "txt";
				break;
			}
		case AttractMode:
			{
				m_FileFilter = "Attract Mode game list files (*.txt)\0*.txt\0";
				m_FileExt = "txt";
				break;
			}
		case Batch:
			{
				m_FileFilter = "batch files (*.bat)\0*.bat\0";
				m_FileExt = "bat";
				break;
			}
		case Cabrio:
			{
				m_FileFilter = "xml files (*.xml)\0*.xml\0";
				m_FileExt = "xml";
				break;
			}
		case CSV:
			{
				m_FileFilter = "csv files (*.csv)\0*.csv\0txt files (*.txt)\0*.txt\0"; //all files (*.*)\0*.*\0";
				m_FileExt = "csv;txt";
				break;
			}
		case HyperSpin:
			{
				m_FileFilter = "xml files (*.xml)\0*.xml\0";
				m_FileExt = "xml";
				break;
			}
		case Khameleon:
			{
				CMalaListDlg dlg;
				//dlg.m_listTitle = malaHeader.FName;
				//dlg.m_listComment = malaHeader.FComment;
				if (dlg.DoModal() == 2)	// cancel button hit?
					return;
				KhameleonListName = dlg.m_listTitle;  
				//malaHeader.FComment = dlg.m_listComment;
				// get filename
				m_FileFilter = "Khameleon Game lists (*.lst)\0*.lst"; 
				m_FileExt = "lst";
				break;
			}
		case MAMEUIFX:
			{
				//CMalaListDlg dlg;
				//dlg.m_listTitle = malaHeader.FName;
				//dlg.m_listComment = malaHeader.FComment;
				//if (dlg.DoModal() == 2)	// cancel button hit?
				//	return;
				//KhameleonListName = dlg.m_listTitle;  
				//malaHeader.FComment = dlg.m_listComment;
				// get filename
				m_FileFilter = "MAMEUIFX lists (*.ini)\0*.ini"; 
				m_FileExt = "ini";
				break;
			}
		case Mala:
			{
				CMalaListDlg dlg;
				dlg.m_listTitle = malaHeader.FName;
				dlg.m_listComment = malaHeader.FComment;
				if (dlg.DoModal() == 2)	// cancel button hit?
					return;
				malaHeader.FName = dlg.m_listTitle;  
				malaHeader.FComment = dlg.m_listComment;
				// get filename
				m_FileFilter = "Mala Game lists (*.mlg)\0*.mlg"; 
				m_FileExt = "mlg";
				break;
			}
		case MameWah:
			{
				// MAMEWah output - just an extended text file 
				// the extension is .lst
				m_FileFilter = "MameWah game list files (*.lst)\0*.lst\0";
				m_FileExt = "lst";
				break;
			}
		case XML:
		case MultiFE:
			{
				m_FileFilter = "xml files (*.xml)\0*.xml\0";
				m_FileExt = "xml";
				break;
			}
		case ROMDesc:	// descriptions only
			{
				m_FileFilter = "text files (*.txt)\0*.txt\0";
				m_FileExt = "txt";
				break;
			}
		case ROMName:
			{
				m_FileFilter = "text files (*.txt)\0*.txt\0";
				m_FileExt = "txt";
				break;
			}
		case Maximus:
			{
				AfxMessageBox("To create a Maximus .LST file you will need to download the Maximus Game List Converter tool from the maximum arcade website.\r\nSimply drag the output .txt file that we're about to create into that tool and it will make your .LST file.\r\n\r\nThis next dialog box will ask you where your ROMs are located, then I'll ask where to save your .txt file list.", MB_ICONINFORMATION, 0);

				// open a "browse to folder" dialog
				if (fileStuff.UserBrowseFolder(m_ROMPath, "Point me to your ROMs folder...") != TRUE)
					return;
				m_ROMPath+="\\";

				m_FileFilter = "Maximus Arcade files (*.txt)\0*.txt"; 
				m_FileExt = "lst";
				break;
			}
		case mGalaxy:
			{
				m_FileFilter = "xml files (*.xml)\0*.xml\0";
				m_FileExt = "xml";
				break;
			}
		}// switch

		// popup a save browser
		fileStuff.m_windowTitle = "Save file as...";
		fileStuff.UserBrowseSave(&m_sFilePath, m_FileFilter, m_FileExt);

		// ok, got filename.  or do we?  if nothing's there, the user hit cancel.  bail out.
		if (m_sFilePath.GetLength() == 0)
			return;
	} // m_previewIt flag

	// if the user wants a preview, we've got no filename, so we pass in a flag instead.
	// when the below worker routines see this special filename, the data collected gets passed back in m_sFilePath
	// kinda stupidly named and wedged in here, but what can ya do?

	if (m_previewIt == true)
		m_sFilePath = "R*L";

	CProgressDlg progDlg;
	progDlg.Init(PROG_MODE_STANDARD, 1000, "Creating list...");

	switch (m_exportFileType.GetCurSel())
	{
	case AdvanceMenuLst:
		{
			m_RL.AdvanceMenuLstMode(m_sFilePath, roms, m_listCount);  // dig up some ROMs
			break;
		}
	case Atomic:
		{
			// Atomic FE output - identical to rom names, except we add the .zip extension and
			// the extension is .cfg
			m_RL.AtomicMode(m_sFilePath, roms, m_listCount);  // dig up some ROMs
			break;
		}
	case AttractMode:
		{
			m_RL.AttractMode(m_sFilePath, roms, m_listCount);  // dig up some ROMs
			break;
		}
	case Batch:
		{
			CbatchFileDlg dlg;
			dlg.m_batchCommand = m_batchCmd; 
			if (dlg.DoModal() == 2)	// cancel button hit?
				break;
			m_batchCmd = dlg.m_batchCommand;	
			m_RL.BatchMode(m_sFilePath, roms, m_listCount, m_batchCmd);  // dig up some ROMs
			break;
		}
	case Cabrio:
		{
			CCarbrioSettingsDlg dlg;
			if (dlg.DoModal() == 2)	// cancel button hit?
				break;
			m_RL.cabrioMode(m_sFilePath, roms, m_listCount, dlg.m_title, dlg.m_path1, dlg.m_path2, dlg.m_path3);  // dig up some ROMs
			break;
		}
	case CSV:
		{
			CCSVDialog dlg;
			dlg.m_delim = ";"; //default to ;  commas are too common in the data output
			if (dlg.DoModal() == 2)	// cancel button hit?
				break;
			m_RL.m_searchItems = dlg.m_cmdLine;
//			m_cmdLine.SetWindowText(dlg.m_cmdLine);	
			m_RL.m_delim = dlg.m_delim;
			
			m_RL.CSVMode(m_sFilePath, roms, m_listCount, dlg.m_columnHeader);  // dig up some ROMs
			break;
		}
	case HyperSpin:
		{
			m_RL.HyperSpinMode(m_sFilePath, roms, m_listCount);  // dig up some ROMs
			break;
		}
	case Khameleon:
		{
			m_RL.KhameleonMode(m_sFilePath, roms, m_listCount,KhameleonListName);  // dig up some ROMs
			break;
		}
	case Mala:
		{
			// convert this current list into mala output
			if (m_sFilePath.GetLength() != 0)
				m_RL.MaLaMode(m_sFilePath, malaHeader, roms, m_listCount);  // dig up some ROMs
		
			break;
		}
	case MAMEUIFX:
		{
			// convert this current list into mala output
			CString Header = "[FOLDER_SETTINGS]\r\nRootFolderIcon cust1\r\nSubFolderIcon cust2\r\n\r\n[ROOT_FOLDER]\r\n";
			if (m_sFilePath.GetLength() != 0)
				m_RL.MAMEUIFxMode(m_sFilePath, Header, roms, m_listCount);  // dig up some ROMs
			break;
		}
	case MameWah:
		{
			// MAMEWah output - just an extended text file 
			// the extension is .lst
			m_RL.MameWahMode(m_sFilePath, roms, m_listCount);  // dig up some ROMs
			break;
		}
	case XML:
	case MultiFE:
		{
			m_RL.XMLMode(m_sFilePath, roms, m_listCount);  // dig up some ROMs
			break;
		}
	case ROMDesc:
		{
			m_RL.DescOnly(m_sFilePath, roms, m_listCount);  // dig up some ROMs
			break;
		}
	case ROMName:
		{
			m_RL.ROMNameOnly(m_sFilePath, roms, m_listCount);  // dig up some ROMs
			break;
		}
	case Maximus:
		{
			m_RL.MaximusMode(m_sFilePath, m_ROMPath, roms, m_listCount);  // dig up some ROMs
			break;
		}
	case mGalaxy:
		{
			m_RL.mGalaxyMode(m_sFilePath, m_ROMPath, roms, m_listCount);  // dig up some ROMs
			break;
		}
	} // switch
	progDlg.DestroyWindow();

	
	if (m_previewIt == true) // user wants a preview?  then display it in the generic output dialog
		{
			CGenericOutputDlg dlg;
			dlg.m_outputTxt = m_sFilePath;
			dlg.m_title = "List Preview";
			dlg.m_buttonFuction1 = BTN_SAVE; // save function
			dlg.DoModal();
		}

	

}


void CRLOutput::OnLvnKeydownRloutputlist(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLVKEYDOWN pLVKeyDow = reinterpret_cast<LPNMLVKEYDOWN>(pNMHDR);
	*pResult = 0;
	CString txt="";
	int nIndex=0;

	if (pLVKeyDow->wVKey == 0x2e) // delete key
	{	
		deleteSelected();
	}

	if ( ( (pLVKeyDow->wVKey > 0x40) && (pLVKeyDow->wVKey < 0x5b) ) || ( (pLVKeyDow->wVKey > 47) && (pLVKeyDow->wVKey < 58) ) )
	{
		while (1) 
		{
			txt = m_listControl.GetItemText(nIndex,1);
			if (txt=="")
				return;
			if (txt.Left(1) == ((char)pLVKeyDow->wVKey) )
			{	
				m_listControl.EnsureVisible(nIndex, FALSE);
				m_listControl.SetSelectionMark(nIndex);
				m_listControl.SetItemState(nIndex, LVIS_SELECTED | LVIS_FOCUSED, 0xFF);
				m_listControl.RedrawItems(nIndex, nIndex);
				m_listControl.UpdateWindow();
				m_listControl.SetFocus();
				return;
			}
			else
				nIndex++;
		}
	}

}

// delete all highlighted items...
void CRLOutput::deleteSelected()
{
	int nIndex=0;
	int lastDeleted=0;
	CString txt;
	while (1) 
	{
		nIndex = m_listControl.GetNextItem(-1, LVNI_SELECTED);
		if (nIndex == -1)
			break;
		else
		{
			m_listControl.DeleteItem (nIndex);
			m_listCount--;
			lastDeleted = nIndex;
		}
	}
	m_listControl.SetSelectionMark(lastDeleted);
	txt.Format("Found:%d matches", m_listCount);
	CDialog::SetWindowText(txt);

}

void CRLOutput::showDetails()
{
	int nIndex=0;
	extern FILE* m_pinputFile;
	CGenericOutputDlg dlg;
	CString tmpDesc, romDesc, txt;	
	extern int g_xmlType;
	xmlType xmlData;

	// get the rom description
	nIndex = m_listControl.GetNextItem(-1, LVNI_SELECTED);
	romDesc = m_listControl.GetItemText(nIndex, 1);
	CString tmp = m_listControl.GetItemText(nIndex, 2);

	// reset the file
	m_file.resetFile(m_pinputFile);

	// get the entire description
	m_file.getROMDesc(m_pinputFile, tmpDesc, xmlData.ROMStart[g_xmlType]+"\""+tmp+"\"");

	// tweak it gently		
	tmpDesc.TrimLeft("\t");
	tmpDesc.Replace("\n\t","\r\n");	//remove 1 tab and replace CR with CR+LF combo 
	tmpDesc.TrimRight();

	if (m_hideSHA1s)
		{
			while (1)
			{
				int pos1 = tmpDesc.Find("<rom name=");
			if (pos1 == -1)
				break;
				int pos2 = tmpDesc.Find("/>",pos1);
			if (pos2 == -1)
				break;
			pos2+=4;
			if (tmpDesc.Mid(pos2,1)=='\r')
				pos2++;
			if (tmpDesc.Mid(pos2,1)=='\n')
				pos2++;

			tmpDesc.Replace(tmpDesc.Mid(pos1, pos2-pos1),"");

			}

		}

	// throw the data over the wall into the new dialog
	dlg.m_outputTxt = tmpDesc;
	dlg.m_title = romDesc;
	dlg.DoModal();
}


void CRLOutput::OnNMDblclkRloutputlist(NMHDR *pNMHDR, LRESULT *pResult)
{
	// TODO: Add your control notification handler code here
	showDetails();
	*pResult = 0;
}


void CRLOutput::OnBnClickedListpreview()
{
	m_previewIt = true;
	OnBnClickedExport();
	m_previewIt = false;
}

// some output types can't be previewed-grey out the preview button when those come up in the list
void CRLOutput::OnCbnSelchangeOutputtype()
{
	switch (m_exportFileType.GetCurSel())
	{
	case Atomic:
	case AttractMode:
	case Batch:
	case CSV:
	case MameWah:
	case ROMDesc:
	case ROMName:
	case HyperSpin:
	case Khameleon:
	case MAMEUIFX:
		{
			((CButton*)GetDlgItem(IDC_LISTPREVIEW))->EnableWindow(1);
			break;			
		}
	case XML:
	case Mala:
	case Maximus:
	case MultiFE:
	case mGalaxy:
		{
			((CButton*)GetDlgItem(IDC_LISTPREVIEW))->EnableWindow(0);
			break;
		}
	} // switch
	
}
