// Rl.cpp : implementation file
//

#include "stdafx.h"
#include "RomLister.h"
#include "Rl.h"
#include "xmlType.h"
#include "malaListDef.h"
#include "errorMessage.h"
#include "mameWahListDef.h"

/*

			int pos=0;
			CString element = "coins";
			CString keyTag = "<input";
			getXMLData(pos, romDesc, keyTag, element, tmp);
*/

// CRl

IMPLEMENT_DYNAMIC(CRl, CWnd)
CRl::CRl()
{
}

CRl::~CRl()
{
}


BEGIN_MESSAGE_MAP(CRl, CWnd)
END_MESSAGE_MAP()


// fixme - we now have code that can do case insenstive searches.  it may or may not be any faster to use it over defaulting to case insensitive and always
// lowercasing the search item+search text every time.

// CRl message handlers
// output 0=wanted 1=not wanted
// this routine is recursively called as large, nested searches are called.  each time it simply returns a yes/no result.
bool CRl::isRomWanted(CString romDesc, CString searchItems)
{
	bool status = 0;
	CString tmp=searchItems;
//	tmp.MakeLower();

	tmp.Replace("`","'");
	
	tmp.Replace("! (","!(");	// remove and leading spaces before a not
	tmp.Replace("- (","-(");	// remove and leading spaces before a not

//	romDesc.MakeLower();
	romDesc.Remove('"');
	int pos, pos2;
	CString item;

	// item in quotes?
	// treat this item as a whole unit, including anything inside
	pos = (tmp.Find("'"));
	if (pos != -1)
	{
		while (tmp.Find("'") != -1)
		{
			pos = (tmp.Find("'"));
			pos++;
			pos2 = tmp.Find("'",pos);
			if (pos2 == -1)
			{
				CErrorMessage err;											// If Set,
				err.m_sMsg.Format("Error, missing 2nd quote mark.");	// Set text
				throw err;	
			}
			
			item = tmp.Mid(pos,pos2-pos);
			status = foundItem(romDesc, item, false); // do not change case on this item
			// trim off entire '..' sequence by adding the ''s back in and removing the entire sequence.
			// then replace the sequence with the results of the find.
			item.Insert(0,"'");
			item+="'";
			if (status == 0) tmp.Replace(item,"=");		// replace '..' sequence with something guaranteed to be found
			if (status == 1) tmp.Replace(item,"jeffrules");    // replace '..' with something not found 
			tmp.TrimRight();			
			tmp.TrimLeft();
			status=0; // clear status
		}
	}

	// parenthesis in search?        ((vertical & cocktail) & (joy4way | joy8way))
	if ( (tmp.Find("(") !=-1) && (tmp.Find(")") !=-1) )
	{
		while (tmp.Find("(") !=-1)
		{
		// locate the last set of () in case they are embedded
		pos = tmp.ReverseFind('(')+1;
		pos2 = tmp.Find(")",pos);
		if (pos2 == -1)	// no end parentheses?  the person goofed
		{
			CErrorMessage err;											// If Set,
			err.m_sMsg.Format("Error, missing parenthesis set\r\nIf you want to search for only 1, put quotes around it.");	// Set text
			throw err;	
		}
		item = tmp.Mid(pos,pos2-pos);
		status = isRomWanted(romDesc, item);
		// trim off entire (..) sequence by adding the ()'s back in and removing the entire sequence.
		// then replace the sequence with the results of the find.
		item.Insert(0,"(");
		item+=")";
	
		if (status == 0) tmp.Replace(item,"=");		// replace (..) sequence with something guaranteed to be found
		if (status == 1) tmp.Replace(item,"jeffrules");    // replace (..) with something not found
		status = 0;
		tmp.TrimRight();			
		tmp.TrimLeft();
		}
	}

	// is this a OR/AND search?
	if ( (tmp.Find("&") > 0) || (tmp.Find("|")> 0) )
	{
		tmp.TrimLeft("()|& ");
		tmp+=" ";	// append a space for our last argument
		while (tmp.GetLength() > 0) 
			{
				// pull out the next item to look for
				item=tmp.Left(tmp.Find(" "));
				tmp.TrimLeft(item);
				tmp.TrimLeft();

				// trade underscores for spaces.
				item.Replace("_"," ");				
			
				status |= foundItem(romDesc, item);
				// was this an OR item?  if we found it, we're done.  Otherwise, keep checking
				if ( (tmp.Left(1) == "|") && (status == 0)) return 0;
				if (tmp.Left(1) == "|") status = 0;				// reset status if OR operator
			// trim off operator and keep chugging along
				tmp.TrimLeft("|& ");
			}
		// return cumulative results from & operations.
		return status;		
	}

	// trade underscores for spaces.
	tmp.Replace("_"," ");

	// otherwise, do a simple search
	return foundItem(romDesc, tmp);
}

// input: item to locate, romDescription, case sensitive flag
// output 0=wanted 1=not wanted
// handle NOT searches here.
bool CRl::foundItem(CString romDesc, CString searchItem, bool lower)
{
	if (lower)
	{
		romDesc.MakeLower();
		searchItem.MakeLower();
	}

	if (searchItem.Find("*") != -1)
		return (wildcardSearch(romDesc, searchItem));
	
	if ( (searchItem.Left(1) == "-") || (searchItem.Left(1) == "!") ) // wanted not?
		{
			searchItem.Trim("-!");
			if (romDesc.Find(searchItem) >= 0 )
				return 1;	
		}
	else
		{
			if (romDesc.Find(searchItem) < 0 )
				return 1;	
		}
	return 0;
}

// output 0=wanted 1=not wanted
bool CRl::wildcardSearch(CString romDesc, CString searchItem)
{
	int pos=0;
	CString leftof, rightof;
	bool not;

	if ( (searchItem.Left(1) == "!") || (searchItem.Left(1) == "-") )
	{
		not=true;
		searchItem.Trim("-!");
	}

	
	// <description>*beast
	while (searchItem.Find("*") != -1)
	{
		leftof = searchItem.Left(searchItem.Find("*"));
		if (!leftof.IsEmpty())
		{
			searchItem.Replace(leftof,"");
			searchItem.TrimLeft("*");
			pos = romDesc.Find(leftof,pos);
			if (pos == -1)
				return true;
			pos++;
		}
		// found left side, check same line for the remainder
		int eol = romDesc.Find("\n",pos);
		CString line = romDesc.Mid(pos, (eol-pos));
		if (line.Find(searchItem) != -1)
			return false;	// yay we found one!
	}	

	return true;
}


//====================================================================================================
// various list outputters and utilties for handling data gathering queries below here
// each main list type outputter is named xyzMode, where xyz is "xml, mala, hyperspin", etc
//====================================================================================================

// locate all romDescs from master file
// assumes file is open by this time.
void CRl::XMLMode(CString &outputFile, CString roms, int romCount)
{
	extern int g_xmlType;
	extern FILE* m_pinputFile;
	FILE* pDataFile;
	CString romDesc;
	xmlType xmlData;
	int sPos=0;			
	int ePos=0;
//	int key;
	int filePos;
	CString tmp;

	// open the file
	if (outputFile != "R*L")
	{
		pDataFile = fopen(outputFile, "wb");  // open the file in overwrite mode
		if ( pDataFile == NULL )
			return;
	}

	m_output = ""; // fresh output
	m_count=0;
	m_total=0;
	m_file.getXMLHeader(m_pinputFile, m_output);
	CString footer = m_file.getXMLFooter(m_output);


	for (int i=0; i<romCount; i++)
	{
		ePos = roms.Find("|",sPos);	// get the next rom name
		tmp = roms.Mid(sPos, ePos-sPos);
		sPos=ePos+1;
		sscanf(tmp,"%x",&filePos);

		m_file.getROMDesc(m_pinputFile, romDesc, "", filePos);
		// convert any unconverted &'s to XML happy "&amp;"  Thanks Josh!
		txt2xml(romDesc);
		//xmlConvert(romDesc);

	//	key = m_file.getROMDesc(m_pinputFile, romDesc, xmlData.ROMStart[g_xmlType]+"\""+tmp+"\"");
	//	if (key == -1) // not sure if we need this now?
	//	{
	//		fseek(m_pinputFile, 0, SEEK_SET);	// start at beginning of file in case we missed it.  the data is here somewhere!
	//		m_file.getROMDesc(m_pinputFile, romDesc, xmlData.ROMStart[g_xmlType]+"\""+tmp+"\"");
	//	}

 


		m_output+=romDesc;		// write this one out
		m_count++;
	}

	// add the final </mame> tag to the end of the file so XML editors are still happy.
		m_output+= "\r\n"+footer;
		m_output+= "\n";

	// write the file
	if (outputFile != "R*L")
	{
		fwrite(m_output, sizeof( char ), m_output.GetLength(), pDataFile);

		// close file, wrap it up.
		if ( pDataFile != NULL )
			{
				fclose(pDataFile);
				pDataFile=NULL;
			}
	}
	else // pass back the data instead of saving it.
		outputFile = m_output;

}
/*
void CRl::xmlConvert(CString &romDesc)
{
	if ( (romDesc.Find(" & ") !=-1) && (romDesc.Find("&amp;") == -1) )
           romDesc.Replace(" & "," &amp; ");		

	if ( (romDesc.Find("&lt;") !=-1))
		romDesc.Replace("&lt;","<");		
	
//	if ( (romDesc.Find("&gt;") !=-1))
//		romDesc.Replace("&gt;",">");
}
*/
// undo common XML formatting strings
void CRl::xml2txt(CString &romDesc)
{
    romDesc.Replace("&amp;","&");		
	romDesc.Replace("&lt;","<");		
	romDesc.Replace("&gt;",">");
	romDesc.Replace("&apos;","'");
	romDesc.Replace("&lt;unknown&gt;","<unknown>");
}
// redo common XML formatting strings
void CRl::txt2xml(CString &romDesc)
{
	if (romDesc.Find("&amp") == -1)
		romDesc.Replace("&", "&amp;");		
	if (romDesc.Find("&apos") == -1)
		romDesc.Replace("'", "&apos;");		
	romDesc.Replace("<<","&lt;<");		
	romDesc.Replace(">>","&gt;>");
	romDesc.Replace("<unknown>","&lt;unknown&gt;");
}
// redo common XML formatting strings to a single tag
void CRl::txt2xmlTag(CString &romDesc)
{
	if (romDesc.Find("&amp") == -1)
		romDesc.Replace("&", "&amp;");	
	if (romDesc.Find("&apos") == -1)
		romDesc.Replace("'", "&apos;");
	romDesc.Replace("<","&lt;");		
	romDesc.Replace(">","&gt;");
}
void CRl::BatchMode(CString &outputFile, CString roms, int romCount, CString batchfileText)
{
	extern FILE* m_pinputFile;
	extern int g_xmlType;
	CString romDesc;
	CString tmp;
	CString name, chd;
	CString batchTmp;
	xmlType xmlData;
	int sPos=0;			
	int ePos=0;
//	bool status;
	FILE* pDataFile;
	int filePos;

	// open the file
	if (outputFile != "R*L")
	{
		pDataFile = fopen(outputFile, "wb");  // open the file in overwrite mode
		if ( pDataFile == NULL )
			return;
	}
	
	m_count=0;
	m_total=0;
//	m_file.locateHeader(m_pinputFile, m_output); // throw away header
	m_output = ""; // fresh output

	for (int i=0; i<romCount; i++)
	{
		ePos = roms.Find("|",sPos);	// get the filePos
		tmp = roms.Mid(sPos, ePos-sPos);
		sPos=ePos+1;
		sscanf(tmp,"%x",&filePos);

		m_file.getROMDesc(m_pinputFile, romDesc, "", filePos); 

		batchTmp = batchfileText;
		getROMName(romDesc, tmp);
		getROMDescription(romDesc, name);
		gatherItem(romDesc, "disk_name=", chd);
		
		batchTmp.Replace("%ROM%",tmp);
		batchTmp.Replace("%DESC%",name);
		batchTmp.Replace("%CHD%",chd);
		batchTmp.Replace("|","\r\n");

		m_output+=batchTmp+"\r\n";
		m_count++;
	}

	// write the file
	if (outputFile != "R*L")
	{
		fwrite(m_output, sizeof( char ), m_output.GetLength(), pDataFile);
		// close file, wrap it up.
		if ( pDataFile != NULL )
			{
				fclose(pDataFile);
				pDataFile=NULL;
			}
	}
	else // pass back the data instead of saving it.
		outputFile = m_output;

}

void CRl::DescOnly(CString &outputFile, CString roms, int romCount)
{
	extern FILE* m_pinputFile;
	extern int g_xmlType;
	CString romDesc;
	CString tmp;
	xmlType xmlData;
	int sPos=0;			
	int ePos=0;

	CString name;
	FILE* pDataFile;
	int filePos;

	// open the file
	if (outputFile != "R*L")
	{
		pDataFile = fopen(outputFile, "wb");  // open the file in overwrite mode
		if ( pDataFile == NULL )
			return;
	}

	m_count=0;
	m_total=0;
//	m_file.locateHeader(m_pinputFile, m_output); // throw away header
	m_output = ""; // fresh output

	for (int i=0; i<romCount; i++)
	{
		ePos = roms.Find("|",sPos);	// get the filePos
		tmp = roms.Mid(sPos, ePos-sPos);
		sPos=ePos+1;
		sscanf(tmp,"%x",&filePos);

		m_file.getROMDesc(m_pinputFile, romDesc, "", filePos); 
//		if (status == false)
//		{
//			fseek(m_pinputFile, 0, SEEK_SET);	// start at beginning of file in case we missed it.  the data is here somewhere!
//			m_file.getROMDesc(m_pinputFile, romDesc, xmlData.ROMStart[g_xmlType]+"\""+tmp+"\"");
//		}

		getROMDescription(romDesc, name);
		name +="\r\n";
		m_output+=name;
		m_count++;
	}

	// write the file
	if (outputFile != "R*L")
	{
		fwrite(m_output, sizeof( char ), m_output.GetLength(), pDataFile);
		// close file, wrap it up.
		if ( pDataFile != NULL )
			{
				fclose(pDataFile);
				pDataFile=NULL;
			}
	}
	else // pass back the data instead of saving it.
		outputFile = m_output;
}

void CRl::ROMNameOnly(CString &outputFile, CString roms, int romCount)
{
	extern FILE* m_pinputFile;
	extern int g_xmlType;
	CString romDesc;
	CString tmp;
	xmlType xmlData;
	int sPos=0;			
	int ePos=0;

	CString name;
	FILE* pDataFile;
	int filePos;

	// open the file
	if (outputFile != "R*L")
	{
		pDataFile = fopen(outputFile, "wb");  // open the file in overwrite mode
		if ( pDataFile == NULL )
			return;
	}
	
	m_count=0;
	m_total=0;
//	m_file.locateHeader(m_pinputFile, m_output); // throw away header
	m_output = ""; // fresh output

	for (int i=0; i<romCount; i++)
	{
		ePos = roms.Find("|",sPos);	// get the filePos
		tmp = roms.Mid(sPos, ePos-sPos);
		sPos=ePos+1;
		sscanf(tmp,"%x",&filePos);

		m_file.getROMDesc(m_pinputFile, romDesc, "", filePos); 
//		if (status == false)
//		{
//			fseek(m_pinputFile, 0, SEEK_SET);	// start at beginning of file in case we missed it.  the data is here somewhere!
//			m_file.getROMDesc(m_pinputFile, romDesc, xmlData.ROMStart[g_xmlType]+"\""+tmp+"\"");
//		}

		getROMName(romDesc, name);
		name +="\r\n";
		m_output+=name;
		m_count++;
	}

	if (outputFile != "R*L")
		{
			// write the file
			fwrite(m_output, sizeof( char ), m_output.GetLength(), pDataFile);

			// close file, wrap it up.
			if ( pDataFile != NULL )
				{
					fclose(pDataFile);
					pDataFile=NULL;
				}
		}
	else // pass back the data instead of saving it.
		outputFile = m_output;
}

void CRl::MAMEUIFxMode(CString &outputFile, CString Header, CString roms, int romCount)
{
	extern FILE* m_pinputFile;
	extern int g_xmlType;
	CString romDesc;
	CString tmp;
	xmlType xmlData;
	int sPos=0;			
	int ePos=0;

	CString name;
	FILE* pDataFile;
	int filePos;

	// open the file
	if (outputFile != "R*L")
	{
		pDataFile = fopen(outputFile, "wb");  // open the file in overwrite mode
		if ( pDataFile == NULL )
			return;
	}
	
	m_count=0;
	m_total=0;
	m_output = ""; // fresh output
	m_output+=Header;

	for (int i=0; i<romCount; i++)
	{
		ePos = roms.Find("|",sPos);	// get the filePos
		tmp = roms.Mid(sPos, ePos-sPos);
		sPos=ePos+1;
		sscanf(tmp,"%x",&filePos);

		m_file.getROMDesc(m_pinputFile, romDesc, "", filePos); 
		getROMName(romDesc, name);
		name +="\r\n";
		m_output+=name;
		m_count++;
	}

	if (outputFile != "R*L")
		{
			// write the file
			fwrite(m_output, sizeof( char ), m_output.GetLength(), pDataFile);

			// close file, wrap it up.
			if ( pDataFile != NULL )
				{
					fclose(pDataFile);
					pDataFile=NULL;
				}
		}
	else // pass back the data instead of saving it.
		outputFile = m_output;
}


void CRl::AtomicMode(CString &outputFile, CString roms, int romCount)
{
	extern FILE* m_pinputFile;
	extern int g_xmlType;
	CString romDesc;
	CString tmp;
	xmlType xmlData;
	int sPos=0;			
	int ePos=0;

	CString name;
	FILE* pDataFile;
	int filePos;

	// open the file
	if (outputFile != "R*L")
	{
		pDataFile = fopen(outputFile, "wb");  // open the file in overwrite mode
		if ( pDataFile == NULL )
			return;
	}

	m_count=0;
	m_total=0;
//	m_file.locateHeader(m_pinputFile, m_output); // throw away header
	m_output = ""; // fresh output

	for (int i=0; i<romCount; i++)
	{
		ePos = roms.Find("|",sPos);	// get the filePos
		tmp = roms.Mid(sPos, ePos-sPos);
		sPos=ePos+1;
		sscanf(tmp,"%x",&filePos);


//		ePos = roms.Find("|",sPos);	// get the next rom name
//		tmp = roms.Mid(sPos, ePos-sPos);
//		sPos=ePos+1;

		m_file.getROMDesc(m_pinputFile, romDesc, "", filePos); 
//		if (status == false)
//		{
//			fseek(m_pinputFile, 0, SEEK_SET);	// start at beginning of file in case we missed it.  the data is here somewhere!
//			m_file.getROMDesc(m_pinputFile, romDesc, xmlData.ROMStart[g_xmlType]+"\""+tmp+"\"");
//		}

		getROMName(romDesc, name);
		name +=".zip\r\n";
		m_output+=name;
		m_count++;
	}

	// write the file
	if (outputFile != "R*L")
	{
		fwrite(m_output, sizeof( char ), m_output.GetLength(), pDataFile);
		// close file, wrap it up.
		if ( pDataFile != NULL )
			{
				fclose(pDataFile);
				pDataFile=NULL;
			}
	}
	else // pass back the data instead of saving it.
		outputFile = m_output;
}

// 1st time list generation. We want name, romname, year and mfgr
// ok, because this is sure to come up, I didn't put buttons and control type in the initial list because of the conflicting
// buttons/numButtons names and missing data from controls.xml not always being available to parse from.  it got ugly.
// this builds a simple cstring of combined data elements that we dig up from the xml file.
// those elements are then passed into the working list folder and displayed in columns.
// the "key" field is the position the rom data was found in the input xml file, so we can jump directly to it to pick out a ROM for exporting when
// we export the final list out.  This gives us the ability to do sorted lists without sequentially parsing each name out of the xml file.
void CRl::initialList()
{
	extern FILE* m_pinputFile;
	extern int g_xmlType;
	CString romDesc;
	CString tmp;
	xmlType xmlData;
	int key;
	m_count=0;
	m_total=0;
//	m_file.locateHeader(m_pinputFile, m_output); // throw away header
	m_output = ""; // fresh output
	m_file.resetFile(m_pinputFile);	// reset the file back to the beginning

	while (1)
		{
			key = m_file.getROMDesc(m_pinputFile, romDesc, xmlData.ROMStart[g_xmlType]);			// grab a complete ROM descriptor
			if (romDesc.GetLength() == 0) break;

			if (! (isRomWanted(romDesc, m_searchItems)) ) // 0=wanted, 1=not wanted.  yeah, goofy.
				{
					tmp.Format("0x%x",key);		// key = position in file this description was found. 
					tmp +="|";
					m_output+=tmp;
					
					getROMName(romDesc, tmp);	// rom name
					tmp +="|";
					m_output+=tmp;

					getROMDescription(romDesc, tmp);	// human readable rom name
					if (tmp.IsEmpty())
						tmp="Unknown";
					tmp +="|";
					m_output+=tmp;
				
					gatherItem(romDesc, "<year>", tmp);	// year of release
					if (tmp.GetLength() < 4)
						tmp = "19??";
					tmp +="|";
					m_output+=tmp;

					gatherItem(romDesc, xmlData.manufacturer[g_xmlType], tmp);	// manufacturer or publisher
					if ( tmp.GetLength() ==0)
						tmp = "?";
					tmp +="|";
					m_output+=tmp;

	//				gatherItem(romDesc, "control_type", tmp);
	//				tmp +="|";
	//				m_output+=tmp;

	//				gatherItem(romDesc, "buttons=", tmp);
	//				if (tmp.GetLength()==0)
	//					tmp="0";
	//				tmp +="|";
	//				m_output+=tmp;

					m_count++;
				}
		}
}

// given the supplied rom name, look up the index key associated with it.
// returns -1 if key not found or m_output is empty (m_output is the data generated by initialList() above.
int CRl::lookupKey(CString romname)
{
	int key = -1;
	int pos;
	romname.Insert(0,"|");
	romname.Append("|");
	CString tmp;

	// see if the supplied romname is in our key list
	pos = m_output.Find(romname);
	if (pos != -1)
		{
			// the key is the file pointer where this rom exists.  scan backwards from gamename til we get the key
			// key is directly in front of the romname, and always starts with |0x
			for (int i=0; i<10; i++)
			{
				pos--;
				if (m_output.Mid(pos,1) == "|")
					break;
			}
			pos++;
			tmp = m_output.Mid(pos,10);	// pull out the key
			sscanf(tmp,"%x",&key);
		}
	return key;
}

// output comma separated values to a text file
void CRl::CSVMode(CString &outputFile, CString roms, int romCount, CString header)
{
	extern FILE* m_pinputFile;
	extern int g_xmlType;
	CString romDesc;
	CString tmp, outTxt;
	xmlType xmlData;
	int sPos=0;			
	int ePos=0;
	CString searchItems;

	CString name;
	FILE* pDataFile;
	int filePos;

	// open the file
	if (outputFile != "R*L")
	{
		pDataFile = fopen(outputFile, "wb");  // open the file in overwrite mode
		if ( pDataFile == NULL )
			return;
	}
	
	m_count=0;
	m_total=0;
//	m_file.locateHeader(m_pinputFile, m_output); // throw away header
	if (!header.IsEmpty())
		header +="\r\n";
	m_output = header; // fresh output


	for (int i=0; i<romCount; i++)
		{
			ePos = roms.Find("|",sPos);	// get the filePos
			tmp = roms.Mid(sPos, ePos-sPos);
			sPos=ePos+1;
			sscanf(tmp,"%x",&filePos);


			m_file.getROMDesc(m_pinputFile, romDesc, "", filePos); 
//			if (status == false)
//			{
//				fseek(m_pinputFile, 0, SEEK_SET);	// start at beginning of file in case we missed it.  the data is here somewhere!
//				m_file.getROMDesc(m_pinputFile, romDesc, xmlData.ROMStart[g_xmlType]+"\""+tmp+"\"");
//			}
			
			searchItems = m_searchItems+",";	// get all items to look for
			CString tmp;
			outTxt="";
			while (!searchItems.IsEmpty())
			{
				// get 1 search item.  they are all separated by commas here
				CString item = searchItems.Left(searchItems.Find(",")+1);
				searchItems.Replace(item,"");
				item.TrimRight(",");
				if ( gatherItem(romDesc, item, tmp) !=-1 ) 
					outTxt+=tmp;
				
				outTxt+=m_delim; // always add the delimiter, even if we didn't find anything
			} // while stuff to search for
			outTxt.TrimRight(m_delim);
			if (!outTxt.IsEmpty())
				{
					outTxt+="\r\n";
					m_output+=outTxt;
					m_count++;
				}
		} // all roms

	// write the file
	if (outputFile != "R*L")
	{
		fwrite(m_output, sizeof( char ), m_output.GetLength(), pDataFile);

		// close file, wrap it up.
		if ( pDataFile != NULL )
			{
				fclose(pDataFile);
				pDataFile=NULL;
			}
	}
	else // pass back the data instead of saving it.
		outputFile = m_output;

}

// returns a CSV string based on search criteria and a rom description entry.
// locates stuff between >xyz</ or "xyz"
// case insensitive.  
// for exact data inside an xml tag, use this format: "%<driver.color"
//		gets the color field data from the driver tag:
//      <driver status="good" emulation="good" color="good" sound="good" graphic="good" savestate="supported" palettesize="768"/>
int CRl::gatherItem(CString romDesc, CString searchItems, CString &output, int startPos, bool findAll)
{
	bool status = true;		// no error checking currently
	// copy romdesc and search items
	CString tmpRomDesc=romDesc;
	CString tmpSearchItems=searchItems;
	tmpRomDesc.MakeLower();
	tmpSearchItems.MakeLower();
	output="";
	CString item;
	CString tmp;
	CString matchData;
	int pos, pos2;
	int foundPos=0;
	CString element, keyTag;

	while (tmpSearchItems.GetLength() > 0)
	{
		// quoted item?  don't tweak it then.
		pos = (tmpSearchItems.Find("'"));
		if (pos != -1)
		{
			while (tmpSearchItems.Find("'") != -1)
			{
				pos = (tmpSearchItems.Find("'"));
				pos++;
				pos2 = tmpSearchItems.Find("'",pos);
				if (pos2 == -1)
				{
					CErrorMessage err;											// If Set,
					err.m_sMsg.Format("Error, missing 2nd quote mark.");	// Set text
					throw err;	
				}
			item = tmpSearchItems.Mid(pos,pos2-pos);
			tmpSearchItems.Replace(item,"");
			tmpSearchItems.Trim("'");
			}
		}

		else // no quotes
		{
			// get the next search item
			tmpSearchItems.Remove('"');
			pos = tmpSearchItems.Find(",");
			if (pos == -1) pos = tmpSearchItems.GetLength();
			item=tmpSearchItems.Left(pos);
	
			tmpSearchItems.Replace(item,"");
			tmpSearchItems.TrimLeft(", ");
			item.Replace("_"," ");  // restore any spaces 
		}

		// item is now the thing we're told to search for.

		// XML tag/element lookup? - this is a specialized search
		if (item.Left(2) == "%<")
		{
			// pull XML tag
			keyTag = item.Mid(1, (item.ReverseFind('.')-1) );
			element = item.Right(item.GetLength() - (item.ReverseFind('.')+1) );

			getXMLData(pos, romDesc, keyTag, element, matchData);
			output+=matchData;
		}
		else
		{
			pos = startPos;
			tmp = "";
			// see if this item is in the romDesc.  Keep looking til all matches for this item have been gathered.
			pos = tmpRomDesc.Find(item, pos);
			while ( pos !=-1)
				{
					foundPos = pos;	// save a marker to where we first located this item
					item.Replace(">","");
					// get everything between " " or < />
					pos+=item.GetLength();	// we should now be sitting on " or > at the start of the item we want to pull.
					// in the case of us trying to locate the game name, this is our search param: "<game"
					// and then there is "name="
					// eg <game name="pacman"
					// or <game romname="pacman"
					// so we need to scoot forward to the first " or <
					// give up after moving 10 spaces forward.  this feels very kludgey.
					for (int i=pos; i<(pos+10); i++)
					{
						if ( (tmpRomDesc.Mid(i,1) != '"') && (tmpRomDesc.Mid(i,1) != '>') )
							pos++;
						else
							break;
					}
					if (tmpRomDesc.Mid(pos,1) == '"') 
						matchData = romDesc.Mid(pos+1, romDesc.Find('"',pos+1)-pos-1);		// copy all characters until another "
					else if (tmpRomDesc.Mid(pos,1) == '>')
						matchData = romDesc.Mid(pos+1, romDesc.Find("</",pos)-pos-1);		// copy all characters until another />

					if (matchData.Left(1) == ">")  // false find?
						matchData = "";

					if (matchData.Left(1) == " ")  // false find? - shouldn't be any spaces at the start of an item
						matchData = "";

					// look for next item.  
					pos +=matchData.GetLength();  // add length of what we just found
					// scan forward looking for terminator for this item (/> or a ")
					while (pos != tmpRomDesc.GetLength())
					{
						if ( (tmpRomDesc.Mid(pos,1)==">") || (tmpRomDesc.Mid(pos,1)=="\"") )
							break;
						pos++;
					}
				
					// prepare for multiple finds
					tmp+=matchData+" & ";
					matchData = "";
					// break out of hte loop if we have a flag set
					if (findAll == false)
						break;

					pos = tmpRomDesc.Find(item, pos);  // locate next match
					// assume there are more items to find.
				}
		}
			// if the item we found has our delimiter in it, replace with underscores
			tmp.Replace(m_delim,"_");

			tmp.TrimRight(" & ");		// remove leftover ands
			// found 'em all.  Add delimiter.  
			if (tmpSearchItems.GetLength() > 0)
				tmp+=m_delim;

			output+=tmp;		
	} // next item.

	// trim off 1 extra delimiter
//	output.TrimRight(m_delim);
	output.Trim();
//	if (output.GetLength() == 0)
//		return -1;
//	else
	return foundPos;
}

void CRl::AttractMode(CString &outputFile, CString roms, int romCount)
{
	// #Name;Title;Emulator;CloneOf;Year;Manufacturer;Category;Players;Rotation;Control;Status;DisplayCount;DisplayType;AltRomname;AltTitle;Extra
	// 88games;'88 Games;mame;;1988;Konami;Sports / Track & Field;4P alt / 2P sim;0;;good;1;raster;;;
	// 99lstwark;'99: The Last War (Kyugo);mame;repulse;1985;Crux / Kyugo;Shooter / Gallery;2P alt;90;joystick (8-way);good;1;raster;repulse;;

	FILE* pDataFile;
	extern int g_xmlType;
	CString romDesc;
	CString tmp;
	xmlType xmlData;
	extern FILE* m_pinputFile;
	int sPos=0;			
	int ePos=0;

	int filePos;

	// open the file
	if (outputFile != "R*L")
	{
		pDataFile = fopen(outputFile, "wb");  // open the file in overwrite mode
		if ( pDataFile == NULL )
			return;
	}
	

	// now on to business.
	m_count=0;
	m_total=0;
	m_output = "#Name;Title;Emulator;CloneOf;Year;Manufacturer;Category;Players;Rotation;Control;Status;DisplayCount;DisplayType;AltRomname;AltTitle;Extra\r\n"; // fresh output


	for (int i=0; i<romCount; i++)
		{
			ePos = roms.Find("|",sPos);	// get the filePos
			tmp = roms.Mid(sPos, ePos-sPos);
			sPos=ePos+1;
			sscanf(tmp,"%x",&filePos);

			m_file.getROMDesc(m_pinputFile, romDesc, "", filePos); 
			m_count++;		


			// rom name
			getROMName(romDesc, tmp);	
			m_output+=tmp+";";

			// user friendly rom details + emulator (always mame)
			getROMDescription(romDesc, tmp);
			m_output+=tmp+";mame;";

			// cloneof / romof
			gatherItem(romDesc, "cloneof=", tmp); 
			m_output+=tmp+";";

			// year
			gatherItem(romDesc, "<year>", tmp);
			m_output+=tmp+";";

			// manufacturer
			gatherItem(romDesc, "<manufacturer>",tmp);
			m_output+=tmp+";";
			
			// category
			gatherItem(romDesc, "<category>", tmp);				
			m_output+=tmp+";";

			// get #players and alt/sim modes
			gatherItem(romDesc, "<nplayers>",tmp);
			m_output+=tmp+";";

			// monitor rotation
			gatherItem(romDesc, "rotate=", tmp);
			m_output+=tmp+";";

			gatherItem(romDesc, "control type=",tmp);
			if (tmp.Find("&") != -1)	
				tmp.Replace(" & ",", ");	// comma delimit multiple controls.
			m_output+=tmp+";";

			// driver status
			gatherItem(romDesc, "%<driver.status", tmp);
			m_output+=tmp+";";

			// display count -- todo!
			m_output+="1;";

			// display type (raster, etc)
			gatherItem(romDesc, "%<display.type=", tmp);
			m_output+=tmp+";";

			// AltRomname;AltTitle;Extra
			m_output+=";;\r\n";


		} // keep goin

	if (outputFile != "R*L")
	{
		fwrite(m_output, sizeof( char ), m_output.GetLength(), pDataFile);

		// close file, wrap it up.
		if ( pDataFile != NULL )
			{
				fclose(pDataFile);
				pDataFile=NULL;
			}
	}
	else // pass back the data instead of saving it.
		outputFile = m_output;


}

// gather up all the stuff required to make a MameWah game list.
// The returned file is still text, so we can output to the screen if we want.
void CRl::MameWahMode(CString &outputFile, CString roms, int romCount)
{
	FILE* pDataFile;
	extern int g_xmlType;
	_mameWahList mameWah;
	CString romDesc;
	CString tmp;
	xmlType xmlData;
	extern FILE* m_pinputFile;
	int sPos=0;			
	int ePos=0;

	int filePos;

	// open the file
	if (outputFile != "R*L")
	{
		pDataFile = fopen(outputFile, "wb");  // open the file in overwrite mode
		if ( pDataFile == NULL )
			return;
	}
	

	// now on to business.
	m_count=0;
	m_total=0;
//	m_file.locateHeader(m_pinputFile, m_output); // throw away header
	m_output = ""; // fresh output


	for (int i=0; i<romCount; i++)
		{
			ePos = roms.Find("|",sPos);	// get the filePos
			tmp = roms.Mid(sPos, ePos-sPos);
			sPos=ePos+1;
			sscanf(tmp,"%x",&filePos);

			m_file.getROMDesc(m_pinputFile, romDesc, "", filePos); 
//			if (status == false)
//			{
//				fseek(m_pinputFile, 0, SEEK_SET);	// start at beginning of file in case we missed it.  the data is here somewhere!
//				m_file.getROMDesc(m_pinputFile, romDesc, xmlData.ROMStart[g_xmlType]+"\""+tmp+"\"");
//			}
			m_count++;		
			// main rom details
			getROMName(romDesc, mameWah.FName);	
			mameWah.FName.MakeUpper();
			// user friendly rom details
			getROMDescription(romDesc, mameWah.FDescription);
			gatherItem(romDesc, "<year>", mameWah.FYear);
			gatherItem(romDesc, "<manufacturer>",mameWah.FManufacturer);
			
			// cloneof / romof
			gatherItem(romDesc, "cloneof=",mameWah.FCloneof); 
			mameWah.FCloneof.MakeUpper();
			gatherItem(romDesc, "romof=",mameWah.FRomof); 
			mameWah.FRomof.MakeUpper();

			// display info
			gatherItem(romDesc, "display type=",mameWah.FVideoScreen);
			// monitor rotation
			gatherItem(romDesc, "rotate=", tmp);
			if ((tmp == "90") || (tmp=="270"))
				mameWah.FVideoOrientation ="Vert";
			else
				mameWah.FVideoOrientation ="Horz";
			

			gatherItem(romDesc, "control type=",mameWah.FControls);
			if (mameWah.FControls.Find("&") != -1)	
				mameWah.FControls.Replace(" & ",", ");	// comma delimit multiple controls.

			// driver status
			// driver status="imperfect" emulation="good" color="good" sound="good" graphic="imperfect" savestate="supported" palettesize="580"/>
			//gatherItem(romDesc, "driver status=",mameWah.FDriverStatus);
			gatherItem(romDesc, "%<driver.status",mameWah.FDriverStatus);
			//gatherItem(romDesc, "emulation=", tmp);
			gatherItem(romDesc, "%<driver.emulation",tmp);
			mameWah.FDriverStatus="Status "+mameWah.FDriverStatus+" ("+tmp+")";

			//gatherItem(romDesc, "color=",mameWah.FDriverColor);
			gatherItem(romDesc, "%<driver.color",mameWah.FDriverColor);
			//gatherItem(romDesc, "graphic=", tmp);
			gatherItem(romDesc, "%<driver.graphic",tmp);
			mameWah.FDriverColor="Color "+mameWah.FDriverColor+" ("+tmp+")";

			//gatherItem(romDesc, "sound=",mameWah.FDriverSound);
			gatherItem(romDesc, "%<driver.sound",mameWah.FDriverSound);
			mameWah.FDriverSound="Sound "+mameWah.FDriverSound;



			// category
			gatherItem(romDesc, "<category>",mameWah.FCategory);	

//			gatherItem(romDesc, "<category>",mala.FGenre);
			
			// controls and inputs
//			gatherItem(romDesc, xmlData.buttons[g_xmlType],tmp);
//			sscanf(tmp,"%d",&mala.FInputButtons);
			

			// add to master output - is there no struc to cstring?
			m_output +=mameWah.FName+"\r\n"+mameWah.FDescription+"\r\n"+mameWah.FYear+"\r\n"+mameWah.FManufacturer+"\r\n"+mameWah.FCloneof+"\r\n";
			m_output +=mameWah.FRomof+"\r\n"+mameWah.FVideoScreen+"\r\n"+mameWah.FVideoOrientation+"\r\n"+mameWah.FControls+"\r\n";
			m_output +=mameWah.FDriverStatus+"\r\n"+mameWah.FDriverColor+"\r\n"+mameWah.FDriverSound+"\r\n"+mameWah.FCategory+"\r\n";
			
			// clear 'em. thisis equally stupid.
			mameWah.FName="";
			mameWah.FYear="";
			mameWah.FManufacturer="";
			mameWah.FCloneof="";
			mameWah.FRomof="";
			mameWah.FVideoScreen="";
			mameWah.FVideoOrientation="";
			mameWah.FControls="";
			mameWah.FDriverStatus="";
			mameWah.FDriverColor="";
			mameWah.FDriverSound="";
			mameWah.FCategory="";
			


		} // keep goin

	if (outputFile != "R*L")
	{
		fwrite(m_output, sizeof( char ), m_output.GetLength(), pDataFile);

		// close file, wrap it up.
		if ( pDataFile != NULL )
			{
				fclose(pDataFile);
				pDataFile=NULL;
			}
	}
	else // pass back the data instead of saving it.
		outputFile = m_output;

}





// gather up all the stuff required to make a MaLa game list.
// this routine writes the file directly instead of gathering up all the data and returning it.
void CRl::MaLaMode(CString outputFile, malaListHeader malaHeader, CString roms, int romCount)
{
	FILE* pDataFile;
	unsigned char buffer[2000]; // storage for a MaLa entry
	unsigned char header[500];
	int size;	// size of this mala entry
	int sPos=0;			
	int ePos=0;
	extern FILE* m_pinputFile;
	extern int g_xmlType;
	// create a mala header structures
	malaList mala;

	CString romDesc;
	CString tmp;
	xmlType xmlData;
	m_countPtr = 0;
	int filePos;

	// open the file
	pDataFile = fopen(outputFile, "wb");  // open the file in overwrite mode
	if ( pDataFile == NULL )
		return;

	// convert the mala header
	convertMalaHeader(malaHeader, &header[0], size);
	fwrite(header, sizeof( char ), size, pDataFile );

	// now on to business.
	m_count=0;
	m_total=0;
	//m_file.locateHeader(m_pinputFile, m_output); // throw away header
	m_output = ""; // fresh output

	for (int i=0; i<romCount; i++)
		{
			ePos = roms.Find("|",sPos);	// get the filePos
			tmp = roms.Mid(sPos, ePos-sPos);
			sPos=ePos+1;
			sscanf(tmp,"%x",&filePos);

			m_file.getROMDesc(m_pinputFile, romDesc, "", filePos); 
//			if (status == false)
//			{
//				fseek(m_pinputFile, 0, SEEK_SET);	// start at beginning of file in case we missed it.  the data is here somewhere!
//				m_file.getROMDesc(m_pinputFile, romDesc, xmlData.ROMStart[g_xmlType]+"\""+tmp+"\"");
//			}
			m_count++;		
			// main rom details
			getROMName(romDesc, mala.FName);				
			gatherItem(romDesc, "romof=",mala.FRomOf); 
			gatherItem(romDesc, "cloneof=",mala.FCloneOf); 
			gatherItem(romDesc, "sourcefile=",mala.FSourcefile);

			// user friendly rom details
			getROMDescription(romDesc, mala.FDescription);
			gatherItem(romDesc, "<year>",tmp);
			//mala.FDescription.Insert(0, tmp+" "); // for cas80 - insert the year before the rom title
			sscanf(tmp,"%d",&mala.FYear);
			gatherItem(romDesc, xmlData.manufacturer[g_xmlType] ,mala.FManufacturer);
			gatherItem(romDesc, "<category>",mala.FGenre);
			
			// controls and inputs
			gatherItem(romDesc, xmlData.buttons,tmp);
			if (tmp =="")
				tmp="0";	
			sscanf(tmp,"%d",&mala.FInputButtons);

			gatherItem(romDesc, "coins=", tmp);
			if (tmp =="")
				tmp="0";	
			sscanf(tmp,"%d",&mala.FInputCoins);


			// get #players and alt/sim modes
			gatherItem(romDesc, "<nplayers>",tmp);
			if (tmp =="")	// no nplayers.ini?  we may be able to build it off controls data
			{
				gatherItem(romDesc, "alternating=",tmp);
				if (tmp =="")
					tmp="1";	// "alternating" not even in the descriptor, assume alternating then.
				sscanf(tmp,"%d",&mala.fAlt);
	
				gatherItem(romDesc, "input_players=", tmp);
				tmp +="P";			// P as in players
				if (mala.fAlt == 1)	// alternating?
					tmp+=" alt";	// "alt" for alternating
				if (mala.fAlt == 0)	// Simulataneous
					tmp+=" sim";	// "sim" for simulatenous
			}
			mala.FInputPlayers = tmp;


			gatherItem(romDesc, "control type=",mala.FInputControl);			// taken from MAME's listxml


			// display info
			gatherItem(romDesc, "display type=",mala.FVideoScreen);
			// monitor rotation
			gatherItem(romDesc, "rotate=", tmp);
			if ((tmp == "90") || (tmp=="270"))
				mala.FVideoOrientation ="vertical";
			else
				mala.FVideoOrientation ="horizontal";
			
			gatherItem(romDesc, "width=", tmp);
			sscanf(tmp,"%d",&mala.FVideoWidth);
			gatherItem(romDesc, "height=", tmp);
			sscanf(tmp,"%d",&mala.FVideoHeight);
			

			// driver status
			gatherItem(romDesc, "%<driver.status",mala.FDriverStatus);
			gatherItem(romDesc, "%<driver.color",mala.FDriverColor);
			gatherItem(romDesc, "%<driver.sound",mala.FDriverSound);
			gatherItem(romDesc, "%<driver.emulation",mala.FDriverEmulation);
			gatherItem(romDesc, "%<driver.graphic",mala.FDriverGraphic);

			
			// controls detail
			gatherItem(romDesc, "'control name='", mala.FControls);			// taken from controls.dat - if no data, this will be blank.
			
			gatherItem(romDesc, "'P1_JOYSTICK_UP\" value='",mala.FJoyUp);
			gatherItem(romDesc, "'P1_JOYSTICK_DOWN\" value='",mala.FJoyDown);
			gatherItem(romDesc, "'P1_JOYSTICK_LEFT\" value='",mala.FJoyLeft);
			gatherItem(romDesc, "'P1_JOYSTICK_RIGHT\" value='",mala.FJoyRight);

			// fudge in some values here if there is no controls.ini data, but we know from MAME's listxml that we have a 4or8way stick.
			// it might be cooler to do this when merging the XML data, then we'd have this for any system that wanted it, not just mala...
			// likewise with the buttons.

			if ( (mala.FControls.GetLength() == 0) && ( (mala.FInputControl == "joy4way") || (mala.FInputControl == "joy8way") ) )
			{
				mala.FJoyUp = "Up";
                mala.FJoyDown = "Down";
				mala.FJoyLeft = "Left";
				mala.FJoyRight = "Right";
				if (mala.FInputControl == "joy4way")
					mala.FControls = "4-way Joystick";
				if (mala.FInputControl == "joy8way")
					mala.FControls = "8-way Joystick";

			}



			gatherItem(romDesc, "'P1_BUTTON1\" value='",mala.FButton1);
			if (mala.FButton1.GetLength() == 0)
			{ 
				if (mala.FInputButtons > 0)
					mala.FButton1 = "button 1";
				else
					mala.FButton1 = "not used";
			}

			gatherItem(romDesc, "'P1_BUTTON2\" value='",mala.FButton2);
			if (mala.FButton2.GetLength() == 0)
			{
				if (mala.FInputButtons > 1)
					mala.FButton2 = "button 2";
				else
					mala.FButton2 = "not used";
			}
			
			gatherItem(romDesc, "'P1_BUTTON3\" value='",mala.FButton3);
			if (mala.FButton3.GetLength() == 0)
			{
				if (mala.FInputButtons > 2)
					mala.FButton3 = "button 3";
				else
					mala.FButton3 = "not used";
			}
			
			gatherItem(romDesc, "'P1_BUTTON4\" value='",mala.FButton4);
			if (mala.FButton4.GetLength() == 0) 
			{
				if (mala.FInputButtons > 3)
					mala.FButton4 = "button 4";
				else
					mala.FButton4 = "not used";
			}

			gatherItem(romDesc, "'P1_BUTTON5\" value='",mala.FButton5);
			if (mala.FButton5.GetLength() == 0)
			{
				if (mala.FInputButtons > 4)
					mala.FButton5 = "button 5";
				else
					mala.FButton5 = "not used";
			}
			
			gatherItem(romDesc, "'P1_BUTTON6\" value='",mala.FButton6);
			if (mala.FButton6.GetLength() == 0)
			{
				if (mala.FInputButtons > 5)
					mala.FButton6 = "button 6";
				else
					mala.FButton6 = "not used";
			}
			
			gatherItem(romDesc, "'P1_BUTTON7\" value='",mala.FButton7);
			if (mala.FButton7.GetLength() == 0)
			{
				if (mala.FInputButtons > 6)
					mala.FButton7 = "button 7";
				else
					mala.FButton7 = "not used";
			}
			
			gatherItem(romDesc, "'P1_BUTTON8\" value='",mala.FButton8);
			if (mala.FButton8.GetLength() == 0)
			{
				if (mala.FInputButtons > 7)
					mala.FButton8 = "button 8";
				else
					mala.FButton8 = "not used";
			}

			// misc
			mala.FPlayed = 0;
		//	mala.FExtension = ".zip";  // not required it seems.  path is also not required.


			// ok, we've gathered up all the stuff we wanted for this ROM.
			// convert it to mala type file, with all the goofy string terminators and stuff.
			convertMalaData(mala, &buffer[0], size);
			fwrite(buffer, sizeof( char ), size, pDataFile );
		} // for 
			

	// close file, wrap it up.
	if ( pDataFile != NULL )
		{
			fclose(pDataFile);
			pDataFile=NULL;
		}

	// one last thing.  One of the offsets has to have the count of ROMs in the file, so open it back up again
	// and modify that single byte.

	// open the file
	if (m_countPtr !=0)	// just in case
	{
		pDataFile = fopen(outputFile, "r+b");  // open the file in read/write mode
		fseek(pDataFile, m_countPtr, SEEK_SET);
		
		fputc((BYTE)m_count, pDataFile);	//(header,sizeof (char),0x40,pDataFile);
		if (m_count > 255)
			fputc((BYTE)(m_count >> 8), pDataFile);	//(header,sizeof (char),0x40,pDataFile);

		fclose(pDataFile);
		pDataFile=NULL;
	}

	

}

//wow.  what a pain in the cheeks this turned out to be.
//this converts the various bits in the mala structure into a packed data buffer.
//
void CRl::convertMalaData(malaList mala, unsigned char *buffer, int &ptr)
{
	ptr=0;
	buffer[ptr] = 01;		// start byte?
	ptr++;

	static char q[1];		// temp storage
	char* mychar = q;

	// rom name (short)
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FName.GetLength();
	ptr++;
	for (int i=0; i<mala.FName.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FName.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}
	
	// FRomOf;				// master oder bios name (parent rom)
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FRomOf.GetLength();
	ptr++;
	for (int i=0; i<mala.FRomOf.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FRomOf.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}
	
	
	//FCloneOf;			// master rom name 
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FCloneOf.GetLength();
	ptr++;
	for (int i=0; i<mala.FCloneOf.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FCloneOf.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}

	//FSourcefile;		// driver name
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FSourcefile.GetLength();
	ptr++;
	for (int i=0; i<mala.FSourcefile.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FSourcefile.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}

	//FDescription;		// game title
	mala.FDescription.Trim();
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FDescription.GetLength();
	ptr++;
	for (int i=0; i<mala.FDescription.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FDescription.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}

	//int FYear;					// year
	buffer[ptr] = 03;
	ptr++;
	buffer[ptr] = (BYTE)mala.FYear;
	ptr++;
	buffer[ptr] = (BYTE)(mala.FYear >> 8);
	ptr++;
	
	//FManufacturer;      // manufacturer
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FManufacturer.GetLength();
	ptr++;
	for (int i=0; i<mala.FManufacturer.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FManufacturer.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}

	//FGenre;				// game genre
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FGenre.GetLength();
	ptr++;
	for (int i=0; i<mala.FGenre.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FGenre.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}

	//FInputButtons;			// control panel button count
	buffer[ptr] = 02;
	ptr++;
	buffer[ptr] = (BYTE)mala.FInputButtons;
	ptr++;

	//FInputCoins;			// control panel coin count
	buffer[ptr] = 02;
	ptr++;
	buffer[ptr] = (BYTE)mala.FInputCoins;
	ptr++;

	//FInputPlayers;      // player count, nplayers information
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FInputPlayers.GetLength();
	ptr++;
	for (int i=0; i<mala.FInputPlayers.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FInputPlayers.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}

	//FInputControl;      // kind of game control
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FInputControl.GetLength();
	ptr++;
	for (int i=0; i<mala.FInputControl.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FInputControl.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}

	//FVideoScreen;       // kind of video screen
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FVideoScreen.GetLength();
	ptr++;
	for (int i=0; i<mala.FVideoScreen.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FVideoScreen.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}
	
	//FVideoOrientation;  // vertical or horizontal
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FVideoOrientation.GetLength();
	ptr++;
	for (int i=0; i<mala.FVideoOrientation.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FVideoOrientation.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}

	//FVideoWidth;			// width of the screen
	buffer[ptr] = 03;
	ptr++;
	buffer[ptr] = (BYTE)mala.FVideoWidth;
	ptr++;
	buffer[ptr] = (BYTE)(mala.FVideoWidth >> 8);
	ptr++;

	//FVideoHeight;			// height of the screen
	buffer[ptr] = 03;
	ptr++;
	buffer[ptr] = (BYTE)mala.FVideoHeight;
	ptr++;
	buffer[ptr] = (BYTE)(mala.FVideoHeight >> 8);
	ptr++;

	//FDriverStatus
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FDriverStatus.GetLength();
	ptr++;
	for (int i=0; i<mala.FDriverStatus.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FDriverStatus.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}

	//FDriverColor
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FDriverColor.GetLength();
	ptr++;
	for (int i=0; i<mala.FDriverColor.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FDriverColor.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}

	//FDriverSound
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FDriverSound.GetLength();
	ptr++;
	for (int i=0; i<mala.FDriverSound.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FDriverSound.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}

	//FDriverEmulation
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FDriverEmulation.GetLength();
	ptr++;
	for (int i=0; i<mala.FDriverEmulation.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FDriverEmulation.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}

	//FDriverGraphic
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FDriverGraphic.GetLength();
	ptr++;
	for (int i=0; i<mala.FDriverGraphic.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FDriverGraphic.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}

   //FControls;			// game controls from controls.dat
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FControls.GetLength();
	ptr++;
	for (int i=0; i<mala.FControls.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FControls.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}

	//FJoyUp;
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FJoyUp.GetLength();
	ptr++;
	for (int i=0; i<mala.FJoyUp.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FJoyUp.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}
    //FJoyDown;
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FJoyDown.GetLength();
	ptr++;
	for (int i=0; i<mala.FJoyDown.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FJoyDown.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}
    //FJoyLeft;
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FJoyLeft.GetLength();
	ptr++;
	for (int i=0; i<mala.FJoyLeft.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FJoyLeft.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}
    //FJoyRight;
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FJoyRight.GetLength();
	ptr++;
	for (int i=0; i<mala.FJoyRight.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FJoyRight.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}
    //FButton1;
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FButton1.GetLength();
	ptr++;
	for (int i=0; i<mala.FButton1.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FButton1.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}
    //FButton2;
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FButton2.GetLength();
	ptr++;
	for (int i=0; i<mala.FButton2.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FButton2.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}
    //FButton3;
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FButton3.GetLength();
	ptr++;
	for (int i=0; i<mala.FButton3.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FButton3.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}
    //FButton4;
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FButton4.GetLength();
	ptr++;
	for (int i=0; i<mala.FButton4.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FButton4.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}
    //FButton5;
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FButton5.GetLength();
	ptr++;
	for (int i=0; i<mala.FButton5.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FButton5.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}
    //FButton6;
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FButton6.GetLength();
	ptr++;
	for (int i=0; i<mala.FButton6.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FButton6.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}
    //FButton7;
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FButton7.GetLength();
	ptr++;
	for (int i=0; i<mala.FButton7.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FButton7.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}
    //FButton8;
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FButton8.GetLength();
	ptr++;
	for (int i=0; i<mala.FButton8.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FButton8.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}
    //FDetails;
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FDetails.GetLength();
	ptr++;
	for (int i=0; i<mala.FDetails.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FDetails.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}

    //FRomPath;			// path of romfile
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FRomPath.GetLength();
	ptr++;
	for (int i=0; i<mala.FRomPath.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FRomPath.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}
    //FExtension;			// extension of romfile
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)mala.FExtension.GetLength();
	ptr++;
	for (int i=0; i<mala.FExtension.GetLength(); i++)
	{
		_tcscpy(mychar, mala.FExtension.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}

	// footer?
	buffer[ptr] = 02;
	ptr++;
	buffer[ptr] = 00;
	ptr++;
	buffer[ptr] = 00;
	ptr++;
}

void CRl::convertMalaHeader(malaListHeader malaHeader, unsigned char *buffer, int &ptr)
{
	ptr=0;
	buffer[ptr] = 01;		// start byte?
	ptr++;

	static char q[1];		// temp storage
	char* mychar = q;

	// list name
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)malaHeader.FName.GetLength();
	ptr++;
	for (int i=0; i<malaHeader.FName.GetLength(); i++)
	{
		_tcscpy(mychar, malaHeader.FName.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}

	//FAuthor;
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = (BYTE)malaHeader.FAuthor.GetLength();
	ptr++;
	for (int i=0; i<malaHeader.FAuthor.GetLength(); i++)
	{
		_tcscpy(mychar, malaHeader.FAuthor.Mid(i,1));	// get next byte
		buffer[ptr] = *mychar;
		ptr++;
	}

	//? doesn't seem to match .mlg raw data;
	buffer[ptr] = 06;
	ptr++;
	buffer[ptr] = 00;
	ptr++;

	// no idea how these bytes are generated.  supposed to be date+time
	// created 11 b1 60 f5 f2 8f 28 e3 40
	buffer[ptr] = 0x11; // signature?
	ptr++;
	buffer[ptr] = 0xb1;
	ptr++;
	buffer[ptr] = 0x60;
	ptr++;
	buffer[ptr] = 0xf5;
	ptr++;
	buffer[ptr] = 0xf2;
	ptr++;
	buffer[ptr] = 0x8f;
	ptr++;
	buffer[ptr] = 0x28;
	ptr++;
	buffer[ptr] = 0xe3;
	ptr++;
	buffer[ptr] = 0x40;		// ender?
	ptr++;

	// modified 11 b1 60 f5 f2 8f 28 e3 40
	buffer[ptr] = 0x11; // signature?
	ptr++;
	buffer[ptr] = 0xb1;
	ptr++;
	buffer[ptr] = 0x60;
	ptr++;
	buffer[ptr] = 0xf5;
	ptr++;
	buffer[ptr] = 0xf2;
	ptr++;
	buffer[ptr] = 0x8f;
	ptr++;
	buffer[ptr] = 0x28;
	ptr++;
	buffer[ptr] = 0xe3;
	ptr++;
	buffer[ptr] = 0x40;		// ender?
	ptr++;

	//FComment - doesn't match typical string either.
	buffer[ptr] = 0x08;
	ptr++;
	
	buffer[ptr] = 0x03;   // count size indicator? 
	ptr++;				// this next byte is the # of roms in teh list

	m_countPtr = ptr;

	buffer[ptr] = 0x01;	// count low
	ptr++;

	buffer[ptr] = 0x00;	// count high
	ptr++;
	

	buffer[ptr] = 0x02;
	ptr++;
	buffer[ptr] = 0x00;	
	ptr++;
	buffer[ptr] = 0x00;		// locked?
	ptr++;


}

// returns a CString from a delphi string binary data
// strings always start with a 06 and then a string length byte.
// input: buffer we're working with
//        ptr in buffer
// output: a string
// ptr updated to just past the string
CString CRl::getMalaString(char* tgtBuffer, int &ptr)
{
	CString res="";
	int size;
	if (tgtBuffer[ptr] != 6)
		return res;
	ptr++;
	size = tgtBuffer[ptr];
	ptr++;
	for (int i=0; i<size; i++)
		res+=tgtBuffer[ptr++];
	return res;
}

// returns a mala game entry
void CRl::getMalaEntry(char* tgtBuffer, int &ptr, malaList &pMalaData)
{
	pMalaData.FName = getMalaString(tgtBuffer, ptr);

	pMalaData.FRomOf = getMalaString(tgtBuffer, ptr);
	pMalaData.FCloneOf = getMalaString(tgtBuffer, ptr);
	pMalaData.FSourcefile = getMalaString(tgtBuffer, ptr);
	pMalaData.FDescription = getMalaString(tgtBuffer, ptr);

	ptr+=3; // skip year? 03 01 00
	pMalaData.FManufacturer = getMalaString(tgtBuffer, ptr);
	pMalaData.FGenre = getMalaString(tgtBuffer, ptr);
	ptr +=4; //skip 2 ints 02 01 02 02
	pMalaData.FInputPlayers = getMalaString(tgtBuffer, ptr);
	// ALT which may or may not be here.  christ.
	// ptr+=?
	pMalaData.FInputControl = getMalaString(tgtBuffer, ptr);
	pMalaData.FVideoScreen = getMalaString(tgtBuffer, ptr);
	pMalaData.FVideoOrientation = getMalaString(tgtBuffer, ptr);

	//ptr +=6; // video width, height 03 04 01 03 e0 00
	while (tgtBuffer[ptr] != 06)
		{ptr++;}
    pMalaData.FDriverStatus = getMalaString(tgtBuffer, ptr);
    pMalaData.FDriverColor = getMalaString(tgtBuffer, ptr);
    pMalaData.FDriverSound = getMalaString(tgtBuffer, ptr);
    pMalaData.FDriverEmulation = getMalaString(tgtBuffer, ptr);
    pMalaData.FDriverGraphic = getMalaString(tgtBuffer, ptr);

	pMalaData.FControls = getMalaString(tgtBuffer, ptr);			// game controls from controls.dat "4-way joystick"
    pMalaData.FJoyUp = getMalaString(tgtBuffer, ptr);				// P1_JOYSTICK_UP 
    pMalaData.FJoyDown = getMalaString(tgtBuffer, ptr);
    pMalaData.FJoyLeft = getMalaString(tgtBuffer, ptr);
    pMalaData.FJoyRight = getMalaString(tgtBuffer, ptr);
    pMalaData.FButton1 = getMalaString(tgtBuffer, ptr);			// "not used" when empty
    pMalaData.FButton2 = getMalaString(tgtBuffer, ptr);
    pMalaData.FButton3 = getMalaString(tgtBuffer, ptr);
    pMalaData.FButton4 = getMalaString(tgtBuffer, ptr);
    pMalaData.FButton5 = getMalaString(tgtBuffer, ptr);
    pMalaData.FButton6 = getMalaString(tgtBuffer, ptr);
    pMalaData.FButton7 = getMalaString(tgtBuffer, ptr);
    pMalaData.FButton8 = getMalaString(tgtBuffer, ptr);
	// miscdetails
	//  romPath
	// extension
	
	// sig for end:
	// 02 00 00 01
	while (! ((tgtBuffer[ptr] == 02) && (tgtBuffer[ptr+1] == 00) && (tgtBuffer[ptr+2] == 00) && (tgtBuffer[ptr+3] == 1)) )
		ptr++;
	ptr+=4; 
}
// helper functions - pulls out the rom name from a description
// romDesc has all the stuff from <game xyz> to </game>
void CRl::getROMName(CString romDesc, CString &romName)
{
	extern int g_xmlType;
	xmlType xmlData;
	int pos;
	pos = romDesc.Find(xmlData.ROMStart[g_xmlType]);
	pos = (romDesc.Find('"',pos))+1;
	romName = romDesc.Mid(pos, (romDesc.Find('"',pos)-pos) );
}

void CRl::getROMDescription(CString romDesc, CString &romDescript)
{
	extern int g_xmlType;
	extern int g_hideTags;
	xmlType xmlData;
    int pos, endpos;
	CString tmp;

	gatherItem(romDesc, xmlData.description[g_xmlType], romDescript);


/*
	pos = romDesc.Find(xmlData.description[g_xmlType]);  // locate either <description> or "gamename="
	pos += xmlData.description[g_xmlType].GetLength();	 // point to whatever comes next
	
	endpos = pos+15; // just in case we don't find either.

	if ( (g_xmlType == MAME)  || (g_xmlType == merged) )
		endpos = romDesc.Find("<",pos);
	else if(g_xmlType == controls)
	{
		pos++;
		endpos = romDesc.Find("\"",pos);
	}

	romDescript = romDesc.Mid(pos, endpos-pos);
*/
	// if hideTags flag is set, remove any data inside ()'s
	if (g_hideTags)
	{
		pos = romDescript.Find("(");
		if (pos != -1)
		{
			endpos = romDescript.ReverseFind(')');
			tmp = romDescript.Mid(pos, endpos-pos+1);
			romDescript.Replace(tmp,"");
			romDescript.Trim();
		}
		
		pos = romDescript.Find("[");
		if (pos != -1)
		{
			endpos = romDescript.ReverseFind(']');
			tmp = romDescript.Mid(pos, endpos-pos+1);
			romDescript.Replace(tmp,"");
			romDescript.Trim();
		}
				
	}
}

// this finds values from within any rom escription based off the xml tag.
// input: romDesc = full data between <game and </game>
//        keyTag = xml tag we're interested in getting
//        element = item within that xml tag to extract
// returns data item
// returns position of item located so next call can find next item.  
// returns -1 for position when no more items are found
// example  keyTag="<input", keyTag="coins"
//          returns XMLData="2" with whatever position in romDesc "coins=" was found inside that tag inside the romdesc.
void CRl::getXMLData(int &position, CString romDesc, CString keyTag, CString element, CString &XMLData)
{
    int pos, endpos;
	CString tmp;
	XMLData = "";
	pos = romDesc.Find(keyTag, position);  // locate start of key
	if (pos == -1)
		{
			position = -1;
			return;
		}
	endpos = romDesc.Find(">",pos);
	tmp = romDesc.Mid(pos, (endpos-pos)+1);

	// tmp now has the xmltag
	pos = tmp.Find(element);
	if (pos ==-1)
	{
		position=-1;
		return;
	}
	
	
	pos+=element.GetLength();	
	// we should now be sitting on " or > at the start of the item we want to pull.  if not, move forward a maximum of 10 spaces til we find a quote
	for (int i=pos; i<(pos+10); i++)
	{
		if (tmp.Mid(i,1) != '"')
			pos++;
		else
			break;
	}

	XMLData = tmp.Mid(pos+1, tmp.Find('"',pos+1)-pos-1);		// copy all characters until another "
}



// gather up all the stuff required to make a mGalaxy game list.
// this routine writes the file directly instead of gathering up all the data and returning it.
/*
<?xml version="1.0" encoding="utf-8"?>
<dbase name="MAME" romset="Mame" version="0.145 (Feb  5 2012)">
  <game name="005" cloneof="">
    <description>005</description>
    <genre>Maze / Shooter Small</genre>
    <players>2P alt</players>
  </game>
  <game name="10yard" cloneof="">
    <description>10-Yard Fight (World, set 1)</description>
    <genre>Sports / Football Amer.</genre>
    <players>2P alt</players>
  </game>
*/
void CRl::mGalaxyMode(CString outputFile, CString romPath, CString roms, int romCount)
{
	FILE* pDataFile;
	extern FILE* m_pinputFile;
	extern int g_xmlType;
		
	CString romDesc, arg, path;
	CString timeTxt;
	CString tmp;
	xmlType xmlData;
	m_countPtr = 0;
	int sPos=0;			
	int ePos=0;

	int filePos;
	CTime t = CTime::GetCurrentTime();
	timeTxt = t.Format("%m/%d/%Y");
	//timeTxt.Trim();


	path = outputFile.Left(outputFile.ReverseFind('\\')+1);

	// open the file
	pDataFile = fopen(outputFile, "wb");  // open the file in overwrite mode
	if ( pDataFile == NULL )
		return;

	// now on to business.
	m_count=0;
	m_total=0;
	m_file.getXMLHeader(m_pinputFile, m_output);

	CString ver;
	gatherItem(m_output, "build=", ver);
	m_output = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\r\n";
	m_output+= "<!-- This file generated by ROMLister -->\r\n";
	m_output+= "<dbase name=\"Multi-system [MAME]\" version=\""+ver+"\" update=\""+timeTxt+"\" comment=\"\">\r\n"; // fixme- scrape this out of the actual header "mame build="
	for (int i=0; i<romCount; i++)
	{
		ePos = roms.Find("|",sPos);	// get the filePos
		tmp = roms.Mid(sPos, ePos-sPos);
		sPos=ePos+1;
		sscanf(tmp,"%x",&filePos);

		m_file.getROMDesc(m_pinputFile, romDesc, "", filePos); 
		m_count++;		
	
		// convert all &'s to XML friendly data
		txt2xml(romDesc);

		//  <game name="10yard" cloneof="">
		getROMName(romDesc, tmp);			// get 8.3 ROM name
		m_output+="  <game name=\""+tmp+"\" cloneof=\"";

		// clone?
		gatherItem(romDesc, "cloneof=", tmp); 
		if (tmp.GetLength() > 0)
			m_output+=tmp;

		m_output+="\" tgdbID=\"\" hidden=\"False\">\r\n";


		// <description>10-Yard Fight (World, set 1)</description>
		getROMDescription(romDesc, tmp);	// get user friendly ROM name
		m_output+="    <description>"+tmp+"</description>\r\n";

		m_output+="    <release>";
		gatherItem(romDesc, "<year>",tmp);
		m_output+=tmp+"</release>\r\n";

		m_output+="    <overview></overview>\r\n";


		// <genre>Maze / Shooter Small</genre>
		m_output+="    <genre>";				// 	<genre>Platform</genre>
		gatherItem(romDesc, "<category>", tmp);	
		m_output +=tmp+"</genre>\r\n";


		// <players>2P alt</players>
		gatherItem(romDesc, "<nplayers>",tmp);
		
		tmp.Replace("1P", "1");
		tmp.Replace("2P", "2");
		tmp.Replace("3P", "3");
		tmp.Replace("4P", "4+");
		tmp.Replace("5P", "4+");
		tmp.Replace("6P", "4+");
		tmp.Replace("8P", "4+");
		tmp.Replace("9P", "4+");
		m_output+="    <players>"+tmp+"</players>\r\n";

		m_output+="  </game>\r\n";
		

	} // keep goin

	m_output+="</dbase>\r\n";
	

	fwrite(m_output, sizeof( char ), m_output.GetLength(), pDataFile);


//	// close file, wrap it up.
	if ( pDataFile != NULL )
		{
			fclose(pDataFile);
			pDataFile=NULL;
		}
}


// gather up all the stuff required to make a Maximus game list.
// this routine writes the file directly instead of gathering up all the data and returning it.
void CRl::MaximusMode(CString outputFile, CString romPath, CString roms, int romCount)
{
	FILE* pDataFile;
	extern FILE* m_pinputFile;
	extern int g_xmlType;
		
	CString romDesc, arg, path;
	CString tmp;
	xmlType xmlData;
	m_countPtr = 0;
	int sPos=0;			
	int ePos=0;

	int filePos;
	
	path = outputFile.Left(outputFile.ReverseFind('\\')+1);

	// open the file
	pDataFile = fopen(outputFile, "wb");  // open the file in overwrite mode
	if ( pDataFile == NULL )
		return;

	// now on to business.
	m_count=0;
	m_total=0;
//	m_file.locateHeader(m_pinputFile, m_output); // throw away header
	m_output = "["; // fresh output

	for (int i=0; i<romCount; i++)
	{
		ePos = roms.Find("|",sPos);	// get the filePos
		tmp = roms.Mid(sPos, ePos-sPos);
		sPos=ePos+1;
		sscanf(tmp,"%x",&filePos);

		m_file.getROMDesc(m_pinputFile, romDesc, "", filePos); 
		//if (status == false)
	//	{
	//		fseek(m_pinputFile, 0, SEEK_SET);	// start at beginning of file in case we missed it.  the data is here somewhere!
	//		m_file.getROMDesc(m_pinputFile, romDesc, xmlData.ROMStart[g_xmlType]+"\""+tmp+"\"");
	//	}

		m_count++;		

		//  "Pac-Man": [#name:"pacman", #cloneof:"puckman", #path:"C:\mame\roms\"
		getROMDescription(romDesc, tmp);	// get user friendly ROM name
		tmp.Insert(0,"\"");
		tmp.Append("\":");
		m_output+=tmp;

		getROMName(romDesc, tmp);			// get 8.3 ROM name
		tmp.Insert(0," [#name: \""); 
		tmp.Append("\",");
		m_output+=tmp;
		
		// clone?
		gatherItem(romDesc, "cloneof=", tmp); 
		if (tmp.GetLength() > 0)
		{
			tmp.Insert(0," #cloneof:\"");
			tmp.Append("\",");
			m_output+=tmp;
		}

		tmp=" #path: \"";
		tmp+=romPath;
		tmp.Append("\"], ");
		m_output+=tmp;

	} // keep goin

		m_output.TrimRight(", ");
		m_output+="]";

		fwrite(m_output, sizeof( char ), m_output.GetLength(), pDataFile);


//	// close file, wrap it up.
	if ( pDataFile != NULL )
		{
			fclose(pDataFile);
			pDataFile=NULL;
		}
	
		
// shell out and convert the file using mameSeer's application.
		//arg = "convert.exe -n -s"+path+"tempRomlister.xyz -d "+outputFile;
		//system (arg);
	//	remove(path+"tempRomlister.xyz");
}

// 
/*CString CRl::extractMaximusEntry(CString &inputData)
{


}
*/

void CRl::cabrioMode(CString &outputFile, CString roms, int romCount, CString m_title, CString m_path1, CString m_path2, CString m_path3)
{
	extern FILE* m_pinputFile;
	extern int g_xmlType;
	CString romDesc;
	CString tmp;
	xmlType xmlData;
	int sPos=0;			
	int ePos=0;

	CString name;
	FILE* pDataFile;
	int filePos;


	// open the file
	if (outputFile != "R*L")
	{
		pDataFile = fopen(outputFile, "wb");  // open the file in overwrite mode
		if ( pDataFile == NULL )
			return;
	}

/*	cabrio header
<cabrio-config>
  <locations>
    <location>
      <type>logo</type>
      <directory>/path/to/my/logos</directory>
    </location>
    <location>
      <type>screenshot</type>
      <directory>/path/to/some/screenshots</directory>
    </location>
    <location>
      <type>background</type>
      <directory>/where/i/keep/my/backgrounds</directory>
    </location>
    ...
  </locations>
  ...
<cabrio-config>
	*/


	m_count=0;
	m_total=0;
	m_output = "<cabrio-config>\r\n";	// fresh output
	m_output +=" <locations>\r\n";
	m_output +="  <location>\r\n";
	m_output +="   <type>logo</type>\r\n"; 
	m_output +="   <directory>"+m_path1+"</directory>\r\n";
	m_output +="  </location>\r\n";

	m_output +="  <location>\r\n";
	m_output +="   <type>screenshot</type>\r\n"; 
	m_output +="   <directory>"+m_path2+"</directory>\r\n";
	m_output +="  </location>\r\n";

	m_output +="  <location>\r\n";
	m_output +="   <type>background</type>\r\n"; 
	m_output +="   <directory>"+m_path3+"</directory>\r\n";
	m_output +="  </location>\r\n";

	m_output +=" </locations>\r\n";

	m_output +=" <game-list>\r\n";
	m_output +="  <name>"+m_title+"</name>\r\n";


/* now for the games section
  <games>
    <game>
      <name>1941 Counter Attack</name>
      <rom-image>1941.zip</rom-image>
      <platform>Arcade</platform>
      <categories>
        <category>
          <name>Genre</name>
          <value>Shooting</value>
        </category>
        <category>
          <name>Controls</name>
          <value>Joystick</value>
        </category>
      </categories>
    </game>
    ...
  </games>
</cabrio-config>
*/

	
	m_output +="  <games>\r\n";



	for (int i=0; i<romCount; i++)
	{
		ePos = roms.Find("|",sPos);	// get the filePos
		tmp = roms.Mid(sPos, ePos-sPos);
		sPos=ePos+1;
		sscanf(tmp,"%x",&filePos);

		m_output+="   <game>\r\n";					//<game>
		m_file.getROMDesc(m_pinputFile, romDesc, "", filePos);
		// convert any unconverted &'s to XML happy "&amp;"  Thanks Josh!
		//xmlConvert(romDesc);
		txt2xml(romDesc);


		m_output+="    <name>";			// <name>Pac Man</name>
		getROMDescription(romDesc, name);
		name +="</name>\r\n";
		m_output+=name;

		m_output+="    <rom-image>";				// <rom-image>pacman.zip</rom-image>
		getROMName(romDesc, name);
		name +=".zip</rom-image>\r\n";
		m_output+=name;

		m_output+="    <platform>Arcade</platform>\r\n";	// hard coded default
		m_output+="    <categories>\r\n";

		// genre - multiple values for each item

		m_output+="     <category>\r\n";
		m_output+="      <name>Genre</name>\r\n";

		name="";
		gatherItem(romDesc, "<category>", name);	
		name+="/ ";
		while (name.Find("/") > -1)
			{
				tmp = name.Left(name.Find("/ "));
				name.TrimLeft(tmp);
				name.TrimLeft(" /");
				tmp.Trim();
				m_output+="      <value>";				
				tmp +="</value>\r\n";
				m_output+=tmp;
				
			}

		m_output+="     </category>\r\n";


		// year
		m_output+="     <category>\r\n";
		m_output+="      <name>Year</name>\r\n";
		m_output+="      <value>";				
		gatherItem(romDesc, "<year>",name);
		name +="</value>\r\n";
		m_output+=name;
		m_output+="     </category>\r\n";



		// manufacturer
		m_output+="     <category>\r\n";
		m_output+="      <name>Manufacturer</name>\r\n";
		m_output+="      <value>";				
		gatherItem(romDesc, xmlData.manufacturer[g_xmlType],name);
		txt2xmlTag(name);	// newer versions of mame have <unknown> instead of "unknown"
		name +="</value>\r\n";
		m_output+=name;
		m_output+="     </category>\r\n";



		m_output+="     <category>\r\n";
		m_output+="      <name>Controls</name>\r\n";

		// control type - multiple values for each item.
		name="";
		gatherItem(romDesc, "control type=",name);			// taken from MAME's listxml
		name+="& ";
		while (name.Find("&") > -1)
			{
				tmp = name.Left(name.Find("& "));
				name.TrimLeft(tmp);
				name.TrimLeft(" &");
				tmp.Trim();
				m_output+="      <value>";				
				tmp +="</value>\r\n";
				m_output+=tmp;
				
			}
		m_output+="     </category>\r\n";


		// # of buttons
		m_output+="     <category>\r\n";
		m_output+="      <name>Buttons</name>\r\n";
		m_output+="      <value>";				
		gatherItem(romDesc, xmlData.buttons,name);	// get count
		name+=" ";
		
		name = name.Left(name.Find(" ",0));
		name.Trim();
		name +="</value>\r\n";
		m_output+=name;
		m_output+="     </category>\r\n";


		m_output+="    </categories>\r\n";
		m_output+="   </game>\r\n";
		m_count++;
	}

	m_output+="  </games>\r\n";
	m_output+=" </game-list>\r\n";
	m_output+="</cabrio-config>\r\n";

	// write the file
	if (outputFile != "R*L")
	{
		fwrite(m_output, sizeof( char ), m_output.GetLength(), pDataFile);
		// close file, wrap it up.
		if ( pDataFile != NULL )
			{
				fclose(pDataFile);
				pDataFile=NULL;
			}
	}
	else // pass back the data instead of saving it.
		outputFile = m_output;


}
/*
hyperspin mode

<menu>
  <game name="btime"> 
	<description>Burger Time (Data East set 1)</description>
	<cloneof></cloneof>
	<manufacturer></manufacturer>
	<year>1982</year>
	<genre>Platform</genre>
  </game>
  <game name="cosmogng">
	<description>Cosmo Gang the Video (US)</description>
	<cloneof></cloneof>
	<manufacturer>Namco</manufacturer>
	<year>1991</year>
	<genre>Shooter</genre>	
  </game>
</menu>
*/
void CRl::HyperSpinMode(CString &outputFile, CString roms, int romCount)
{
	extern FILE* m_pinputFile;
	extern int g_xmlType;
	CString romDesc;
	CString tmp;
	xmlType xmlData;
	int sPos=0;			
	int ePos=0;

	CString name;
	FILE* pDataFile;
	int filePos;


	// open the file
	if (outputFile != "R*L")
	{
		pDataFile = fopen(outputFile, "wb");  // open the file in overwrite mode
		if ( pDataFile == NULL )
			return;
	}

	m_count=0;
	m_total=0;
//	m_file.locateHeader(m_pinputFile, m_output); // throw away header
	m_output = "<menu>\r\n"; // fresh output

	for (int i=0; i<romCount; i++)
	{
		ePos = roms.Find("|",sPos);	// get the filePos
		tmp = roms.Mid(sPos, ePos-sPos);
		sPos=ePos+1;
		sscanf(tmp,"%x",&filePos);


		m_file.getROMDesc(m_pinputFile, romDesc, "", filePos); 
		

		// convert any unconverted &'s to XML happy "&amp;"  Thanks Josh!
		//xmlConvert(romDesc);
		txt2xml(romDesc);

//		if (status == false)
//		{
//			fseek(m_pinputFile, 0, SEEK_SET);	// start at beginning of file in case we missed it.  the data is here somewhere!
//			m_file.getROMDesc(m_pinputFile, romDesc, xmlData.ROMStart[g_xmlType]+"\""+tmp+"\"");
//		}

		if (romDesc.Find("unknown") != -1)
			int g=0;

		m_output+="\t<game name=\"";			// <game name="btime"> 
		getROMName(romDesc, name);
		name +="\">\r\n";
		m_output+=name;

		m_output+="\t\t<description>";			// <description>Burger Time (Data East set 1)</description>
		getROMDescription(romDesc, name);
		name +="</description>\r\n";
		m_output+=name;

		
		m_output+="\t\t<cloneof>";				// 	<cloneof></cloneof>
		gatherItem(romDesc, "cloneof=",name); 
		name +="</cloneof>\r\n";
		m_output+=name;

		m_output+="\t\t<manufacturer>";				// 	<manufacturer></manufacturer>

		gatherItem(romDesc, xmlData.manufacturer[g_xmlType], name);
		txt2xmlTag(name);	// newer versions of mame have <unknown> instead of "unknown"
		name +="</manufacturer>\r\n";
		m_output+=name;

	
		m_output+="\t\t<year>";				// 	<year>1991</year>
		gatherItem(romDesc, "<year>", name);
		name +="</year>\r\n";
		m_output+=name;

	
		m_output+="\t\t<genre>";				// 	<genre>Platform</genre>
		gatherItem(romDesc, "<category>", name);	
		name +="</genre>\r\n";
		m_output+=name;

		m_output+="\t</game>\r\n";
		m_count++;
	}

	m_output+="</menu>\r\n";


	// write the file
	if (outputFile != "R*L")
	{
		fwrite(m_output, sizeof( char ), m_output.GetLength(), pDataFile);
		// close file, wrap it up.
		if ( pDataFile != NULL )
			{
				fclose(pDataFile);
				pDataFile=NULL;
			}
	}
	else // pass back the data instead of saving it.
		outputFile = m_output;
}
// Khameleon game lists.
// xml mode, lots of fields.
/*
<GameList>
   <Category_Name>All Games</Category_Name>
   <Category_Image></Category_Image>
   <KonfigParams>34</KonfigParams>
   <DatFilename></DatFilename>
   <XMLFilename></XMLFilename>
   <ListFilename>allgames.lst</ListFilename>
   <FilterFilename>allgames.flt</FilterFilename>
   <Version>2</Version>
   <Entry>
      <m_gamename>005</m_gamename>
      <m_description>005</m_description>
      <m_manufacturer>Sega</m_manufacturer>
      <m_cloneof>005</m_cloneof>
      <m_catinfo>Maze / Shooter Small</m_catinfo>
      <year>1981</year>
      <orientation>270</orientation>
      <screentype>raster</screentype>
      <xsize>256</xsize>
      <ysize>224</ysize>
      <controls>
         <control>
            <ControlName>paddle</ControlName>
         </control>
         <control>
            <ControlName>pedal</ControlName>
         </control>
      </controls>
      <ButtonCount>1</ButtonCount>
      <NOSP>1</NOSP>
      <MNOP>2</MNOP>
      <Gameplay></Gameplay>
      <ControlLayout></ControlLayout>
      <DriverStatus>imperfect</DriverStatus>
      <ColorStatus>good</ColorStatus>
      <SoundStatus>imperfect</SoundStatus>
      <Emulator>MAME</Emulator>
      <RomParms></RomParms>
   </Entry>
.
.
.
</GameList>

*/
void CRl::KhameleonMode(CString &outputFile, CString roms, int romCount, CString listName)
{
	extern FILE* m_pinputFile;
	extern int g_xmlType;
	CString romDesc;
	CString tmp;
	CString header = "<GameList>\r\n   <Category_Name>All Games</Category_Name>\r\n   <Category_Image></Category_Image>\r\n   <KonfigParams>34</KonfigParams>\r\n   <DatFilename></DatFilename>\r\n   <XMLFilename></XMLFilename>\r\n   <ListFilename>allgames.lst</ListFilename>\r\n   <FilterFilename>allgames.flt</FilterFilename>\r\n   <Version>2</Version>\r\n";
	
	xmlType xmlData;
	int sPos=0;			
	int ePos=0;
	int p;
	CString name;
	FILE* pDataFile;
	int filePos;

	header.Replace("All Games",listName);

	// open the file
	if (outputFile != "R*L")
	{
		pDataFile = fopen(outputFile, "wb");  // open the file in overwrite mode
		if ( pDataFile == NULL )
			return;
	}

	m_count=0;
	m_total=0;
//	m_file.locateHeader(m_pinputFile, m_output); // throw away header
	m_output = header; // fresh output

	for (int i=0; i<romCount; i++)
	{
		ePos = roms.Find("|",sPos);	// get the filePos
		tmp = roms.Mid(sPos, ePos-sPos);
		sPos=ePos+1;
		sscanf(tmp,"%x",&filePos);

		m_file.getROMDesc(m_pinputFile, romDesc, "", filePos); 
		// convert any unconverted &'s to XML happy "&amp;"  Thanks Josh!
		//xmlConvert(romDesc);
		txt2xml(romDesc);

//		if (status == false)
//		{
//			fseek(m_pinputFile, 0, SEEK_SET);	// start at beginning of file in case we missed it.  the data is here somewhere!
//			m_file.getROMDesc(m_pinputFile, romDesc, xmlData.ROMStart[g_xmlType]+"\""+tmp+"\"");
//		}
		m_output+="   <Entry>\r\n";			// <Entry> 

		m_output+="      <m_gamename>";			// <m_gamename>005</m_gamename>
		getROMName(romDesc, name);
		tmp = name;								// save for cloneof below
		name +="</m_gamename>\r\n";
		m_output+=name;

		m_output+="      <m_description>";		// <m_description>005</m_description>
		getROMDescription(romDesc, name);
		name +="</m_description>\r\n";
		m_output+=name;

		m_output+="      <m_manufacturer>";				// 	<m_manufacturer>Sega</m_manufacturer>
		gatherItem(romDesc, xmlData.manufacturer[g_xmlType], name);
		txt2xmlTag(name);	// newer versions of mame have <unknown> instead of "unknown"
		name +="</m_manufacturer>\r\n";
		m_output+=name;


		m_output+="      <m_cloneof>";					// 	<m_cloneof>005</m_cloneof>
		gatherItem(romDesc, "cloneof=",name); 
		if (name.GetLength() == 0)
			name = tmp;
		name +="</m_cloneof>\r\n";
		m_output+=name;

		m_output+="      <m_catinfo>";				// 	<m_catinfo>Maze / Shooter Small</m_catinfo>
		gatherItem(romDesc, "<category>", name);	
		name +="</m_catinfo>\r\n";
		m_output+=name;

		m_output+="      <year>";				// 	<year>1981</year>
		gatherItem(romDesc, "<year>", name);
		name +="</year>\r\n";
		m_output+=name;
      
		m_output+="      <orientation>";				// 	<orientation>270</orientation>
		gatherItem(romDesc, "rotate=", name);
		name +="</orientation>\r\n";
		m_output+=name;
      
		m_output+="      <screentype>";				// 	<screentype>raster</screentype>
		gatherItem(romDesc, "display type=", name);
		name +="</screentype>\r\n";
		m_output+=name;
    
		m_output+="      <xsize>";				// 	<xsize>256</xsize>
		gatherItem(romDesc, "width=", name);
		name +="</xsize>\r\n";
		m_output+=name;
      
		m_output+="      <ysize>";				// 	<ysize>224</ysize>
		gatherItem(romDesc, "height=", name);
		name +="</ysize>\r\n";
		m_output+=name;

		m_output+="      <controls>\r\n";
		// while loop here on multiple controls.

		gatherItem(romDesc, "control type=", name);
		while (1)
		{
			m_output+="         <control>\r\n";

			m_output+="            <ControlName>";				// 	<ControlName>joy4way</ControlName>
	
			p = name.Find("&");
			tmp = name;
			if (p != -1)
			{
				tmp = name.Left(p-1);
				name.TrimLeft(tmp);
				name.Trim(" & ");
				name.Trim();
			}

			tmp+="</ControlName>\r\n";
			m_output+=tmp;

			m_output+="         </control>\r\n";
			
			if (p == -1)  // finished?
				break;
		}
		m_output+="      </controls>\r\n";


		m_output+="      <ButtonCount>";				// 	<ButtonCount>1</ButtonCount>
		gatherItem(romDesc, "buttons=", name);
		p = name.Find("&");							// this'll dig up multiple buttons= if controls.dat data is present. Use only the first one found, which is from controls
		if (p != -1)									// that should be more accurate than the 2nd one, which comes from MAME itself.
		{
			name = name.Left(p-1);
			name.Trim();
		}
		if (name == "")
			name = "0";

		name +="</ButtonCount>\r\n";
		m_output+=name;

		// no. of simul players.  if alternating = 0 then num of simul players must = number of input players right?!?
		m_output+="      <NOSP>";				// 	<NOSP>1</NOSP>
		gatherItem(romDesc, "alternating=", tmp);
		gatherItem(romDesc, "input_players=", name);

		if (tmp == "0")	// not alternating?
			tmp = name;	// 
		if (tmp == "") // no data?
			tmp = "1";

		tmp +="</NOSP>\r\n";
		m_output+=tmp;

		m_output+="      <MNOP>";				// 	<MNOP>2</MNOP>
		name +="</MNOP>\r\n";
		m_output+=name;
      
		m_output+="      <Gameplay></Gameplay>\r\n";	// <Gameplay></Gameplay>  what is this?
		m_output+="      <ControlLayout></ControlLayout>\r\n";	// <ControlLayout></ControlLayout>  what is this?

		// driver status
		m_output+="      <DriverStatus>";				// 	<DriverStatus>imperfect</DriverStatus>
		//gatherItem(romDesc, "driver_status=", name);
		gatherItem(romDesc, "%<driver.status",name);
		name +="</DriverStatus>\r\n";
		m_output+=name;
      
		m_output+="      <ColorStatus>";				// 	<ColorStatus>good</ColorStatus>
		//gatherItem(romDesc, "color=", name);
		gatherItem(romDesc, "%<driver.color",name);
		name +="</ColorStatus>\r\n";
		m_output+=name;

		m_output+="      <SoundStatus>";				// 	<SoundStatus>imperfect</SoundStatus>
		//gatherItem(romDesc, "sound=", name);
		gatherItem(romDesc, "%<driver.sound",name);
		name +="</SoundStatus>\r\n";
		m_output+=name;

		m_output+="      <Emulator>MAME</Emulator>\r\n";	// <Emulator>MAME</Emulator>
		m_output+="      <RomParms></RomParms>\r\n";	// <RomParms></RomParms>
      
		m_output+="   </Entry>\r\n";
		m_count++;
	}

	m_output+="</GameList>\r\n";


	// write the file
	if (outputFile != "R*L")
	{
		fwrite(m_output, sizeof( char ), m_output.GetLength(), pDataFile);
		// close file, wrap it up.
		if ( pDataFile != NULL )
			{
				fclose(pDataFile);
				pDataFile=NULL;
			}
	}
	else // pass back the data instead of saving it.
		outputFile = m_output;
}
void CRl::AdvanceMenuLstMode(CString &outputFile, CString roms, int romCount)
{
	extern FILE* m_pinputFile;
	extern int g_xmlType;
	CString romDesc;
	CString tmp;
	CString header = "";
	
	xmlType xmlData;
	int sPos=0;			
	int ePos=0;

	CString name;
	FILE* pDataFile;
	int filePos;

	//header.Replace("All Games",listName);

	// open the file
	if (outputFile != "R*L")
	{
		pDataFile = fopen(outputFile, "wb");  // open the file in overwrite mode
		if ( pDataFile == NULL )
			return;
	}

	m_count=0;
	m_total=0;
//	m_file.locateHeader(m_pinputFile, m_output); // throw away header
	m_output = header; // fresh output

	for (int i=0; i<romCount; i++)
	{
		ePos = roms.Find("|",sPos);	// get the filePos
		tmp = roms.Mid(sPos, ePos-sPos);
		sPos=ePos+1;
		sscanf(tmp,"%x",&filePos);

		m_file.getROMDesc(m_pinputFile, romDesc, "", filePos); 
		// convert any unconverted &'s to XML happy "&amp;"  Thanks Josh!
		//xmlConvert(romDesc);
		//txt2xml(romDesc);

/*
sample entry:

game (
       name adventure_vision
	   description "Adventure Vision (USA)"
	   year 1982
	   manufacturer "Entex Industries, Inc"
	   cloneof xyz
)

*/


		m_output+="game (\r\n";			

		m_output+="      name ";			
		getROMName(romDesc, name);
		m_output+=name+"\r\n";

		m_output+="      description \"";		
		getROMDescription(romDesc, name);
		name.Replace("\r","");
		name.Replace("\n","");
		name +="\"\r\n";
		m_output+=name;

		m_output+="      year ";				
		gatherItem(romDesc, "<year>", name);
		name +="\r\n";
		m_output+=name;

		m_output+="      manufacturer \"";				
		gatherItem(romDesc, xmlData.manufacturer[g_xmlType], name);
		txt2xmlTag(name);	// newer versions of mame have <unknown> instead of "unknown"
		name +="\"\r\n";
		m_output+=name;

		gatherItem(romDesc, "cloneof=",name); 
		if (!name.IsEmpty())
		{
			m_output+= "      cloneof ";
			m_output+=name;
			m_output+="\r\n";
		}

		m_output+=")\r\n";
		m_count++;
	}

		xml2txt(m_output);	// remove xml formatting, this is a lst file.


//footer	m_output+="</GameList>\r\n";


	// write the file
	if (outputFile != "R*L")
	{
		fwrite(m_output, sizeof( char ), m_output.GetLength(), pDataFile);
		// close file, wrap it up.
		if ( pDataFile != NULL )
			{
				fclose(pDataFile);
				pDataFile=NULL;
			}
	}
	else // pass back the data instead of saving it.
		outputFile = m_output;
}
