// RomLister.cpp : Defines the class behaviors for the application.
//
// ROMLister - a tool to isolate ROMs out of the MAME set that suit your needs.
// code and concept by jeff leyda 2006-2007.  jeff@silent.net
//
// this source code is free for you to do with what you wish.
// the registry stuff is taken from a project on the code project website.  No credit taken for that stuff.
// you'll get a lot of warnings when compiling it, but it still seems to do the job. (and BTW, registry.cpp does
// not use precompiled headers, in case you ever need to rebuild the solution file.)
// 

#include "stdafx.h"
#include "RomLister.h"
#include "RomListerDlg.h"
#include "mamebrowser.h"
#include "xmlType.h"
#include <process.h>
#include "registry.h"
#include "RLSearchItemsListDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CRomListerApp

BEGIN_MESSAGE_MAP(CRomListerApp, CWinApp)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

// globals, cuz I'm too lazy to do anything else
int g_xmlType=-1;
int g_hideTags;
FILE* m_pinputFile = NULL;
CRLAllROMsListDlg* gm_pwndAllROMsListDlg; // undo these
CRLSearchItemsListDlg* gm_pwndRLSearchItemsListDlg;
CRLOutput* gm_pwndRLOutput;
CString g_sRLpath; // path to where we're running from
CRLOutPutDlgThd* gm_pRLOutputThd;
CRLAllROMsDlgThd* gm_pRLAllROMsThd;
CRLSearchItemsThd* gm_pRLSearchItemsThd;

CString prevSearches[MAX_SEARCHES];
int searchNum=0;
int prevIndex=0;


// CRomListerApp construction

CRomListerApp::CRomListerApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CRomListerApp object

CRomListerApp theApp;


// CRomListerApp initialization

BOOL CRomListerApp::InitInstance()
{
	extern int g_hideTags;
	CString tmp;
	// InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	InitCommonControls();
	
	CWinApp::InitInstance();

	AfxEnableControlContainer();


	LPTSTR buff = g_sRLpath.GetBuffer(MAX_PATH);
	
	GetModuleFileName(NULL, buff, MAX_PATH);
	tmp = buff;
	g_sRLpath=(tmp.Left(tmp.ReverseFind('\\')));
	g_sRLpath+="\\";
	SetCurrentDirectory(g_sRLpath);
	g_sRLpath.ReleaseBuffer();










	m_fileName = "";
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("ROMLister"));

	// dig out the last accessed xml file here.
	// if it doesn't exist, then pop up the intro message.
	CRegistry regMyReg( NULL );  // No special flags
	
	CRomListerDlg dlg3; // prepare to launch main GUI
	dlg3.m_gotoOptions = false;

	// try to get paths from registry
	if ( regMyReg.Open("Software\\ROMLister",HKEY_CURRENT_USER) ) 
	{
		// get the data
		m_fileName = regMyReg["inputXMLFile"];
		sscanf(regMyReg["hideSHA1s"],"%d",&dlg3.m_hideSHA1s);
		sscanf(regMyReg["hideTags"],"%d",&g_hideTags);
		// Close the open key
		regMyReg.Close();

//		m_filePath = m_fileName.Left(m_fileName.ReverseFind('\\')+1);
//		m_fileName.Replace(m_filePath,"");  // everything leftover is the filename
//		dlg3.m_workingPath = m_filePath;
		dlg3.m_xmlFilename = m_fileName;
		
	}
	else  // first timer?

	{
		CMameBrowser dlg;
		//m_pMainWnd = &dlg;
		INT_PTR nResponse = dlg.DoModal();
		if (nResponse != IDOK)
			return FALSE;	// user hit quit 
		else 
			// set a flag in the main dialog that we need to go into the options window
			dlg3.m_gotoOptions = true;
	} 


	dlg3.DoModal();	
			
		

//	else if (nResponse == IDCANCEL)
//	{
//		// TODO: Place code here to handle when the dialog is
//		//  dismissed with Cancel
//	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

/*
here's some C# code from headKaze that does the command line -listxml thing without popping up the black DOS screen.

bool retValue;
string Application = MamePath;
string CommandLine = " -listxml";
PROCESS_INFORMATION pi = new PROCESS_INFORMATION();
STARTUPINFO si = new STARTUPINFO();
SECURITY_ATTRIBUTES sa = new SECURITY_ATTRIBUTES();
sa.nLength = Marshal.SizeOf(sa); // sizeof(sa)
sa.bInheritHandle = 1;
sa.lpSecurityDescriptor = IntPtr.Zero; // null

string sTempFile = Path.Combine(StartupPath, "ListInfo.xml");
IntPtr hFile = CreateFile(sTempFile, GENERIC_READ | GENERIC_WRITE, 0, ref sa, CREATE_ALWAYS, 0, IntPtr.Zero);

si.cb = Marshal.SizeOf(si);
si.hStdOutput = hFile;
si.dwFlags = STARTF_USESTDHANDLES;

retValue = CreateProcess(Application, CommandLine, ref sa, ref sa, true, NORMAL_PRIORITY_CLASS | CREATE_NO_WINDOW, IntPtr.Zero, null, ref si, out pi);

WaitForSingleObject(pi.hProcess, INFINITE); // wait for list generation to finish

CloseHandle(hFile);
CloseHandle(pi.hProcess);
CloseHandle(pi.hThread);[code]


*/