// RomListerDlg.h : header file
//

#pragma once
#include "afxwin.h"
#include "filestuff.h"
#include "rl.h"
#include "RLAllROMSDlgThd.h"
#include "RLOutputDlgThd.h"
#include "RLSearchItemsThd.h"



// CRomListerDlg dialog
class CRomListerDlg : public CDialog
{
// Construction
public:
	CRomListerDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_ROMLISTER_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	CEdit m_RomDescTxt;
	CEdit m_cmdLine;
	afx_msg void OnBnClickedCocktailonly();
	afx_msg void OnBnClickedUpright();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedTweakCmdLine(unsigned int ID);
//	void enableWizard(bool enabled);
	void loadInputFile();

	CComboBox m_numButtons;
	CString m_xmlFilename;
	int	m_hideSHA1s;			// cleanup display option
	CString m_ROMDescTxtBox;  // for output in text window only
	CString m_xmlHeader;
	FILE* m_outfile;


	CFileStuff m_file;
	CRl m_RL;
	CString m_cmdLineTxt;
	CString m_searchCriteria;
	bool	m_anyCheck;
	bool	m_gotoOptions;

	afx_msg void OnCbnSelchangeNumbuttons();
	bool doButtons(CString &criteria);
	bool doHorizontal(CString &criteria);
	bool doVertical(CString &criteria);
	bool doControls(CString &criteria);
	bool doCocktail(CString &criteria);
	bool doMisc(CString &criteria);
	bool doRegions(CString &criteria);
	bool doCategory(CString &criteria);
	bool doNplayers(CString &criteria);
//	void displayROMDesc();
//	void outputXMLinWindow(CString output);
//	void saveToFile(CString data);
	bool expandMacros();
//	afx_msg void OnBnClickedNextromdesc();
//	afx_msg void OnBnClickedPrevromdesc();
	afx_msg void OnBnClickedRomsearch();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedoutputTypeRange(unsigned int ID);

//	afx_msg void OnBnClickedViewinput();
//	afx_msg void OnBnClickedViewoutput();
	
	afx_msg void OnEnChangeCmdline();
	afx_msg void OnBnClickedSettings();
//	CComboBox m_categoryType;
//	afx_msg void OnCbnSelchangeCategorytype();
	void disableCategorySelection(bool allowed);
	void enableNPlayersSelection(bool allowed);
	void loadHistory();
	CString m_verticalTxt;
	CString m_horizontalTxt;
	CComboBox m_region;
	afx_msg void OnCbnSelchangeRegion();
	afx_msg void OnBnClickedRegionNot();
//	bool m_fOutputListOpen;

//jlp2	CRLOutPutDlgThd *m_pRLOutputThd;
//jlp2	CRLAllROMsDlgThd *m_pRLAllROMsThd;

	

	afx_msg void OnBnClickedListallroms();
	afx_msg void OnBnClickedCatany();
	afx_msg void OnBnClickedPrevsearchbtn();
	afx_msg void OnBnClickedNextsearchbtn();
};
